/***************************************************************************
 *	cd_word.c: λ
 *			
 *			Version 1.10		1994/04/19 (Tues.) --
 *			Version 1.50		1997/09/13 (Sat.) --
 *			
 *			Programed by Nobuyuki Maruichi
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <sys/dir.h>

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "cdda_ext.h"
#include "mwxcd.h"
#include "cd_word.h"

#define	FALSE	0
#define	TRUE	1

WordsError LyricsError = WordsErrorNone;

/***************************************************************************
 *	trackWordAlloc: λ죱ʬΥݤ
 *	
 *		TrackWord *trackWordAlloc(void);
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		λ죱ʬΥݤ롣
 *		ջ֤ȥȥϡ00:00.00ɤ NULL ˽롣
 *		
 *		ǤϤΰʬΥݡޤ
 *		ʸؤݥ󥿤ϡNULLȤơʬϥݤޤ
 *		Ƥϰʲ˼
 *		
 *		ݤλ쨬
 *		
 *		ɽϻ֨ġ00:00.00ɨ
 *		
 *		λʣԡ˨ NULL ݥ
 *		
 *		ؤΥ󥯨 NULL ݥ
 *		
 *		
 *		꤬ݤ줿硢嵭Τ褦˽줿ؤݥ
 *		֤ޤ
 ***************************************************************************/
TrackWord *trackWordAlloc(void)
{
	TrackWord *alloc_ptr = NULL;
	static const struct cd_time zero_time = {0,0,0};
	
	alloc_ptr = (TrackWord*)malloc(sizeof(TrackWord));
	if(alloc_ptr != NULL) {
		alloc_ptr->wordTime = zero_time;
		alloc_ptr->word = NULL;
		alloc_ptr->next_ptr = NULL;
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	wordRelease: λѤΣʬ
 *	
 *		void wordRelease(TrackWord *release_ptr);
 *	
 *		TrackWord *release_ptr;		λ󥯥ȥꥹȤΥ
 *	֤
 *		
 *	
 *		λ쨬
 *		release_ptr ꡡ
 *		
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭡
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 ***************************************************************************/
void wordRelease(TrackWord *release_ptr)
{
	if(release_ptr != NULL) {
		free(release_ptr->word);
		free(release_ptr);
	}
}

/***************************************************************************
 *	wordLinkRelease: λѤΥʷˡʰʬˤ
 *	
 *		void wordLinkRelease(TrackWord *lyric);
 *	
 *		TrackWord *lyric;		λ󥯥ȥꥹȤΥ
 *	֤
 *		
 *	
 *		ºݤ˲ϰʲ̤
 *		
 *		λƬ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		λ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		NULLݥ
 *		
 ***************************************************************************/
void wordLinkRelease(TrackWord *lyric)
{
	TrackWord *release_ptr;
	
	while(lyric != NULL) {
		release_ptr = lyric;
		lyric = lyric->next_ptr;
		wordRelease(release_ptr);
	}
}

/***************************************************************************
 *	wordCount: λʰʬˤιԿ򥫥Ȥ
 *	
 *		int wordCount(TrackWord *lyric);
 *	
 *		TrackWord *lyric;		Ȥλ󥯥ȥꥹȤΥݥ
 *	֤
 *		λιԿ
 *	
 *		λʰʬˤιԿλ󥯤ɤäƥȤ
 *		
 *		λƬ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		λ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		NULLݥ
 *		
 ***************************************************************************/
int wordCount(TrackWord *lyric)
{
	int counter;
	
	counter = 0;
	while(lyric != NULL) {
		lyric = lyric->next_ptr;
		++counter;
	}
	return(counter);
}

/***************************************************************************
 *	wordsLength: λʰʬˤʸХȿ򥫥Ȥ
 *	
 *		int wordsLength(TrackWord *lyric);
 *	
 *		TrackWord *lyric;		Ȥλ󥯥ȥꥹȤΥݥ
 *	֤
 *		
 *	
 *		λʰʬˤβλ󥯤ɤäʸХȿȤ
 *		
 *		λƬ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		βλ󥯤ʸĨȤʸ
 *		
 *		λ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		NULLݥ
 *		
 ***************************************************************************/
int wordsLength(TrackWord *lyric)
{
	int counter;
	
	counter = 0;
	while(lyric != NULL) {
		counter += strlen(lyric->word) + 1;
		lyric = lyric->next_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	wordCountSearch: λʰʬˤ椫Ԥõ
 *	
 *		TrackWord *wordCountSearch(TrackWord *lyric, int lines);
 *	
 *		TrackWord *lyric;		λ󥯥ȥꥹȤΥݥ
 *		int lines;				Ԥιֹ
 *	֤
 *		NULL:			ԤĤʤä
 *		NULLʳ:		ꤵ줿
 *	
 *		 lyric λ󥯥ȥꥹȤΥݥ
 *		
 *		 lyric
 *		
 *		
 *		λƬ*lyric˨ֹ棰βλ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		ֹlinesβλ
 *		
 *		ɽϻ֨ι¤Τؤ
 *		ݥ󥿤֤ͨ
 *		λʣԡ˨ʸ󨭨Ȥʤ롡
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		λ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		NULLݥ
 *		
 *		
 ***************************************************************************/
TrackWord *wordCountSearch(TrackWord *lyric, int lines)
{
	int counter;
	
	for(counter = 0;lyric != NULL && counter < lines;
					lyric = lyric->next_ptr,++counter)
		;											/*  */
	return(lyric);
}

/***************************************************************************
 *	wordsptrCountSearch: λʥȥåˤλֹ򥵡
 *	
 *		TrackWord **wordsptrCountSearch(TrackWord **lyric_ptr_ptr, int lines);
 *	
 *		TrackWord **lyric_ptr_ptr;	λʥȥå
 *		int lines;					Ԥιֹ
 *	֤
 *		NULL:			ԤĤʤä
 *		NULLʳ:		ꤵ줿Ԥؤݥ󥿤Υݥ
 *	
 *		λʥȥåˤλֹؤ󥯥ݥ󥿤õ
 *		ʤֹ椬ξϡͤ򤽤Τޤ֤
 *		
 *		 lyric_ptr_ptr λ󥯥ȥꥹȤΥݥ
 *		
 *		 lyric_ptr_ptr
 *		
 *		
 *		
 *		λؤݥ󥿨ġĲλμؤΥ󥯤ƱǤ
 *		
 *		
 *		λƬֹ棰βλ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		ֹlines-1βλ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		֤ͨ
 *		
 *		ֹlinesβλ
 *		
 *		ɽϻ֨ι¤Τõ
 *		Ƥ뤬֤ͨ
 *		λʣԡ˨ʸ󨭨ϡΥݥ󥿨
 *		ؤ󥯡ݨ
 *		ؤΥ󥯨󥿤Υɥ쥹
 *		
 *		
 *		
 *		
 *		
 *		λ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		NULLݥ
 *		
 *		
 ***************************************************************************/
TrackWord **wordsptrCountSearch(TrackWord **lyric_ptr_ptr, int lines)
{
	int counter;
	
	for(counter = 0;*lyric_ptr_ptr != NULL && counter < lines;
			lyric_ptr_ptr = &(*lyric_ptr_ptr)->next_ptr,++counter)
		;											/*  */
	return((counter < lines)?(NULL):(lyric_ptr_ptr));
}

/***************************************************************************
 *	wordTimeSearch: λλ־󤫤ֹ򥵡
 *	
 *		int wordsTimeSearch(TrackWord *lyric, struct cd_time *wordTime_ptr);
 *	
 *		TrackWord *lyric;		Ȥλ󥯥ȥꥹȤΥݥ
 *		struct cd_time *wordTime_ptr;	
 *	֤
 *		EOF:	֤Ĥʤä
 *		ʾ:	ֹ
 *	
 *		λλ־󤫤ֹ򥵡
 *		
 *		
 *		 lyric
 *		
 *		
 *		λƬ
 *		
 *		ɽϻ֨оݡ
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		֤ãƤʤλ
 *		
 *		ɽϻ֨оݡ
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		ְʾβλ
 *		
 *		ɽϻ֨оݡιֹ椬
 *		֤ͤȤʤ먢
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		λ
 *		
 *		ɽϻ֨
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		NULLݥ
 *		
 *		
 ***************************************************************************/
int wordsTimeSearch(TrackWord *lyric, struct cd_time *wordTime_ptr)
{
	int counter;
	int lyric_counter = EOF;
	unsigned long int searchFrame;
	
	searchFrame = time2frame(wordTime_ptr);
	counter = 0;
	while((lyric != NULL)?(time2frame(&lyric->wordTime)<searchFrame):(FALSE)) {
		lyric_counter = counter;
		lyric = lyric->next_ptr;
		++counter;
	}
	return(lyric_counter);
}

/***************************************************************************
 *	wordsTime: λѤλ־ե졼̵ǡѴ
 *	
 *		int wordsTime(struct cd_time *time);
 *	
 *		struct cd_time *time;
 *	֤
 *		EOF: 		־ǤϤʤȤ򼨤̵
 *		ʾ: 	ե졼
 *	
 *		ʲΤ褦ʲλΤǤϡΥСǤ⤢־
 *		̵ͭȽꤷơͭǤФλ֤ե졼֤Ѵ
 *		֤
 *		
 *		ͨ
 *		λʣʬˡ־ʾܺ١ˡ
 *		
 *		ɽϻ֨minuteġʬ
 *		
 *		λʣԡ˨secondġá
 *		
 *		ؤΥ󥯨frame ĥե졼ਭ
 *		
 *		
 *		ǡʬ 255 λϡ̵ʻ־Ȥư
 *		
 *		ʤե졼ϡ074 ͤȤޤĤޤ꣱á75ե졼Ǥ
 *		ե졼֤ؤѴȤϡʬäե졼ñ̤ѴҤȤ򼨤
 *		ޤ
 *		
 ***************************************************************************/
int wordsTime(struct cd_time *time)
{
	long int frame;

	if(time->minute != 255)
		frame = time2frame(time);
	else
		frame = EOF;
	return(frame);
}

/***************************************************************************
 *	wordsTimeCheck: λλϰϥå
 *	
 *		int wordsTimeCheck(struct cd_time *time, int start, int end);
 *	
 *		struct cd_time *time;
 *		int start;
 *		int end;
 *	֤
 *		: 	ϰ
 *		: 	ϰϳ
 *	
 *		־󤬡ꤵ줿֤ϰˤ뤫ƱȽꤷޤ
 ***************************************************************************/
int wordsTimeCheck(struct cd_time *time, int start, int end)
{
	long int frame;

	frame = wordsTime(time);
	return(frame <= start || frame >= end);
}

/***************************************************************************
 *	lyricCmp: λƤӤԤ
 *	
 *		int lyricCmp(TrackWord *lyric1, TrackWord *lyric2);
 *	
 *		TrackWord *lyric1;	λʰʬ
 *		TrackWord *lyric2;	λʰʬ
 *	֤
 *		EOF: 		λ󤬤ʤ
 *		: 		־̷ǡʤ
 *		ʾ: 	־̷ǡ
 *					ͤϡ̷⤬Կ1
 *	
 *		λƥȤιȽ˻ѤƤޤ
 ***************************************************************************/
int lyricCmp(TrackWord *lyric1, TrackWord *lyric2)
{
	int flag = 0;
	
	while(lyric1 != NULL && lyric2 != NULL && flag == 0) {
		if(lyric1->word != NULL && lyric2->word != NULL)
			flag = strcmp(lyric1->word, lyric2->word);
		else
			flag = True;
		lyric1 = lyric1->next_ptr;
		lyric2 = lyric2->next_ptr;
	}
	if(flag == False) {
		flag = ((lyric1 != NULL) != (lyric2 != NULL));
	}

	return(flag);
}

/***************************************************************************
 *	wordsTimeTest: λå
 *	
 *		int wordsTimeTest(TrackWord *lyric, 
 *							struct cd_time *start, struct cd_time *end);
 *	
 *		TrackWord *lyric;
 *		struct cd_time *start;
 *		struct cd_time *end;
 *	֤
 *		EOF: 		λ󤬤ʤ
 *		: 		־̷ǡʤ
 *		ʾ: 	־̷ǡ
 *					ͤϡ̷⤬Կ1
 *	
 *		
 ***************************************************************************/
int wordsTimeTest(TrackWord *lyric, struct cd_time *start, struct cd_time *end)
{
	int flag = EOF;
	WordsError error = WordsIllegalOrder;
	int counter;
	int limit;
	unsigned long int testFrame;
	extern AppData app_data;
	
	limit = wordsTime(end);
	for(testFrame = wordsTime(start), counter = 0;((lyric!=NULL)?
			!(flag=wordsTimeCheck(&lyric->wordTime, testFrame, limit)):(0));
								++counter, lyric = lyric->next_ptr) {
		testFrame = wordsTime(&lyric->wordTime);
		if(strlen(lyric->word) > app_data.wordsCoLimit) {
			flag = 1;
			error = WordsTooLong;
			break;
		}
	}
	if(flag == 1) {
		LyricsError = error;
		return(counter + 1);
	}
	return(flag);
}

/***************************************************************************
 *	discWordCount: ʬβλιԿ򥫥Ȥ
 *	
 *		int discWordCount(DiscWord *lyrics);
 *	
 *		DiscWord *lyrics;		ǥβλ
 *	֤
 *		EOF			λʤ
 *		ʾ		λιԿ
 *	
 *		
 ***************************************************************************/
int discWordCount(DiscWord *lyrics)
{
	int counter;
	int lines = EOF;
	TrackWord **trackWords_ptr_ptr;

	if(lyrics->trackWords != NULL) {
		trackWords_ptr_ptr = lyrics->trackWords;
		for(counter = 0, lines = 0;counter < lyrics->tracks;++counter) {
			/*
			 *	λ򥫥
			 */
			lines += wordCount(*(trackWords_ptr_ptr + counter));
		}
	}
	return(lines);
}

/***************************************************************************
 *	DiscWordAlloc: ǥʬβλѤΥƤ
 *	
 *		DiscWord *DiscWordAlloc(int tracks);
 *	
 *		int tracks;		ǥΥȥå
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		ǥʬβλѤΥƤơʲΤ褦˽
 *		롣ºݤβλǡ϶Ǥ롣
 *		
 * 		λǡ¤
 *		
 *		λԿ
 *		
 *		ǥΥȥå trackʥȥåˤ
 *		
 *		λؤΥݥ󥿤Υݥ󥿨ĥȥåʬΥݥؤ
 *		
 *		
 *		
 *		
 *		λؤΥݥ󥿣 NULL ݥ
 *		
 *		λؤΥݥ󥿣 NULL ݥ
 *		
 *		ġ
 *		
 *		λؤΥݥ󥿣ب NULL ݥ
 *		
 *		λǡι¤Ρ
 ***************************************************************************/
DiscWord *DiscWordAlloc(int tracks)
{
	int counter;
	DiscWord *alloc_ptr = NULL;

	alloc_ptr = (DiscWord*)malloc(sizeof(DiscWord));
	if(alloc_ptr != NULL) {
		alloc_ptr->lines = 0;
		alloc_ptr->tracks = tracks;
		alloc_ptr->trackWords = 
					(TrackWord**)malloc(sizeof(TrackWord*)*tracks);
		if(alloc_ptr->trackWords != NULL) {
			for(counter = 0;counter < tracks;++counter) {
				*(alloc_ptr->trackWords + counter) = NULL;
			}
		} else {
			free(alloc_ptr);
			alloc_ptr = NULL;
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	DiscWordRelease: ʬβλѤΥ
 *	
 *		void DiscWordRelease(DiscWord *lyrics);
 *	
 *		DiscWord *lyrics;		ǥβλ
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		ǥʬβλϡʲΤ褦ʷˤʤäƤޤ
 *		ϡƤǤ
 *		
 *		
 *		ʬβλ󨬨
 * 		
 * 		λǡ¤Ψ
 *		
 *		λԿ
 *		
 *		ǥΥȥå
 *		
 *		λؤΥݥ󥿤Υݥ󥿨
 *		
 *		
 *		
 *		λΥݥ󨬨ƥȥåβλ󥯨
 *		
 *		
 *		λؤΥݥ󥿣 λޤϡNULL ݥ󥿡
 *		
 *		ġ
 *		
 *		λؤΥݥ󥿣ͨλλĢNULL
 *		
 *		λؤΥݥ󥿣Ψ NULL ݥ󥿡
 *		
 *		ġ
 *		
 *		λؤΥݥ󥿣ب λޤϡNULL ݥ󥿡
 *		
 *		
 *		
 *		
 ***************************************************************************/
void DiscWordRelease(DiscWord *lyrics)
{
	int counter;
	TrackWord **release_ptr_ptr;

	if(lyrics != NULL) {
		if(lyrics->trackWords != NULL) {
			release_ptr_ptr = lyrics->trackWords;
			for(counter = 0;counter < lyrics->tracks;++counter) {
				/*******************************
				 *	ƥȥåβλ
				 *******************************/
				wordLinkRelease(*(release_ptr_ptr + counter));
			}
			free(release_ptr_ptr);		/* ݥ */
		}
	}
	free(lyrics);	/* λǡ¤Τ */
}

/***************************************************************************
 *	stearchChar: ʸʸƬʸ򥫥Ȥ
 *	
 *		int stearchChar(const unsigned char *string, int c);
 *	
 *		const unsigned char *string;	оݤʸ
 *		int c;							ʸ
 *	֤
 *		ƬʸƬΥեåȡ
 *	
 *		
 ***************************************************************************/
int stearchChar(const unsigned char *string, int c)
{
	int counter = EOF;
	
	if(string != NULL) {
		for(counter = 0;*string != '\0' && *string != c;++counter, ++string)
			;					/*  */
	}
	return(counter);
}

/***************************************************************************
 *	remakeEditWords: Խλȴ¸βλ줫λǡƹ
 *	
 *		int remakeEditWords(TrackWord **lyric_ptr_ptr, 
 *									const unsigned char *string);
 *	
 *		TrackWord **lyric_ptr_ptr;		ȥåβλǡƬ򤵤
 *										ݥ󥿤Υݥ
 *		const unsigned char *string;	Խλȡʣԡ
 *	֤
 *		EOF:	̿Ūʥ顼ʥ­
 *		:		顼ʤ
 *	
 *		
 ***************************************************************************/
int remakeEditWords(TrackWord **lyric_ptr_ptr, const unsigned char *string)
{
	int length, lastChar;
	int errorFlag = 0, endOfString = False;
	struct cd_time noTime = {255,255,255};
	TrackWord *trackWord, **wordsTrackTop = lyric_ptr_ptr;
	TrackWord *release_ptr, *next_release_ptr;

	next_release_ptr = *lyric_ptr_ptr;
	if(string != NULL) {
		while((*string != '\0' || endOfString || 
					*lyric_ptr_ptr != NULL) && errorFlag == False) {
			release_ptr = next_release_ptr;
			if(release_ptr != NULL)
				next_release_ptr = release_ptr->next_ptr;

			length = stearchChar(string, '\n');
			trackWord = trackWordAlloc();
			if(trackWord != NULL) {
				trackWord->word = (char*)malloc(length + 1);
				if(trackWord->word != NULL) {
					snprintf(trackWord->word, length + 1, "%s", string);
					if(release_ptr != NULL)
						trackWord->wordTime = release_ptr->wordTime;
					else
						trackWord->wordTime = noTime;
				} else {
					errorFlag = EOF;
				}
			} else {
				errorFlag = EOF;
			}
			wordRelease(release_ptr);
			*lyric_ptr_ptr = trackWord;
			lyric_ptr_ptr = &trackWord->next_ptr;
			lastChar = *(string + length);
			string += length + (endOfString = (lastChar == '\n'));
		}
	}
	if(errorFlag != False) {
		wordLinkRelease(next_release_ptr);
		wordLinkRelease(*wordsTrackTop);
		*wordsTrackTop = NULL;
	}
	return(errorFlag);
}

/***************************************************************************
 *	isWordTimeString: 
 *	
 *		int isWordTimeString(const char *wrdTimeString);
 *	
 *		const char *wrdTimeString;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int isWordTimeString(const char *wrdTimeString)
{
	int wordTimeString;
	static const char *timeDigit = " 1234567890";

	wordTimeString =  (strchr(timeDigit, *wrdTimeString) != NULL);
	wordTimeString &= (strchr(timeDigit, *(wrdTimeString+1)) != NULL);
	wordTimeString &= (*(wrdTimeString+2) == ':');
	wordTimeString &= (strchr(timeDigit, *(wrdTimeString+3)) != NULL);
	wordTimeString &= (strchr(timeDigit, *(wrdTimeString+4)) != NULL);
	wordTimeString &= (*(wrdTimeString+5) == ':');
	wordTimeString &= (strchr(timeDigit, *(wrdTimeString+6)) != NULL);
	wordTimeString &= (strchr(timeDigit, *(wrdTimeString+7)) != NULL);
	wordTimeString &= (*(wrdTimeString+8) == '=');
	return(wordTimeString);
}

/***************************************************************************
 *	getWordTracks: λϿƤǸΥȥåֹ
 *	
 *		int getWordTracks(FILE *stream);
 *	
 *		FILE *stream;			եݥ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int getWordTracks(FILE *stream)
{
	int track;
	int lines;
	unsigned char buffer[1024];
	char *status_ptr;
	char separator1;

	status_ptr = fgets(buffer, sizeof(buffer), stream);
	if(status_ptr != NULL) {
		sscanf(buffer, "%d", &lines);
		status_ptr = fgets(buffer, sizeof(buffer), stream);
	}
	while(status_ptr != NULL) {
		sscanf(buffer, "%c%d", &separator1, &track);
		status_ptr = fgets(buffer, sizeof(buffer), stream);
		if(status_ptr != NULL) {
			while((status_ptr != NULL)?(buffer[0] != '#'):(FALSE)) {
				status_ptr = fgets(buffer, sizeof(buffer), stream);
				if(status_ptr != NULL) {
					switch(buffer[0]) {
					default:
						if(isWordTimeString(buffer)) {
							/* ɤ߹ǲλʸʬɤФ */
							status_ptr = 
									fgets(buffer, sizeof(buffer), stream);
						}
						break;
					case '#':
						break;
					}
				}
			}
		}
	}
	return(track);
}

/***************************************************************************
 *	getWord: λ
 *	
 *		void getWord(DiscWord *discWords, FILE *stream);
 *	
 *		DiscWord *discWords;	
 *		FILE *stream;			եݥ
 *	
 *		
 ***************************************************************************/
void getWord(DiscWord *discWords, FILE *stream)
{
	int track, len;
	int minute, second, frame;
	int counter;
	unsigned char buffer[1024];
	char separator1, separator2;
	char *status_ptr;
	TrackWord *trackWord, **endWord_ptr_ptr;

	status_ptr = fgets(buffer, sizeof(buffer), stream);
	if(status_ptr != NULL) {
		sscanf(buffer, "%d", &discWords->lines);
		status_ptr = fgets(buffer, sizeof(buffer), stream);
	}
	while(status_ptr != NULL) {
		counter = 0;
		sscanf(buffer, "%c%d", &separator1, &track);
		track -= (track > 0);				/* ºݤˤϡ--track Ʊ */
		endWord_ptr_ptr = discWords->trackWords + track;
		trackWord = trackWordAlloc();
		status_ptr = fgets(buffer, sizeof(buffer), stream);
		if(status_ptr != NULL && trackWord != NULL) {
			while((status_ptr != NULL)?(buffer[0] != '#'):(FALSE)) {
				sscanf(buffer, "%d%c%d%c%d", 
						&minute, &separator1, &second, &separator2, &frame);
				trackWord->wordTime.minute = minute;
				trackWord->wordTime.second = second;
				trackWord->wordTime.frame  = frame;
				status_ptr = fgets(buffer, sizeof(buffer), stream);
				if(status_ptr != NULL) {
					len = strlen(buffer);
					while((len > 0)?
							(iscntrl(buffer[len-1]) && 
							buffer[len-1]<0x80):(FALSE))
						--len;
					buffer[len] = '\0';
					trackWord->word = (char*)malloc(strlen(buffer) + 1);
					if(trackWord->word != NULL)
						strcpy(trackWord->word, buffer);
					status_ptr = fgets(buffer, sizeof(buffer), stream);
					*endWord_ptr_ptr = trackWord;
					endWord_ptr_ptr = &trackWord->next_ptr;
					trackWord = trackWordAlloc();
				}
			}
		}
		free(trackWord);
	}
}

/***************************************************************************
 *	putWord: ʥǥΡ˲λ WHIPS WRD եؽ񤭽Ф
 *	
 *		void putWord(DiscWord *discWords, FILE *stream);
 *	
 *		DiscWord *discWords;	ǥʬβλ
 *		FILE *stream;			񤭽Фоݡʥեݥ󥿡
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void putWord(DiscWord *discWords, FILE *stream)
{
	int track;
	int lines;
	TrackWord *trackWord;
	
	lines = discWordCount(discWords);
	fprintf(stream, "%d\r\n", lines);
	for(track = 0;track < discWords->tracks;++track) {
		trackWord = *(discWords->trackWords + track);
		if(trackWord != NULL) {
			fprintf(stream, "#%2d#\r\n", track + 1);
			while(trackWord != NULL) {
				fprintf(stream, "%2d:%2d:%02d=%2d\r\n", 
					trackWord->wordTime.minute, 
					trackWord->wordTime.second, trackWord->wordTime.frame, 1);
				fprintf(stream, "%s\r\n", trackWord->word);
				trackWord = trackWord->next_ptr;
			}
		}
	}
}

/***************************************************************************
 *	makeWords: ȥåβλʸκ
 *	
 *		char **makeWords(TrackWord *lyric);
 *	
 *		TrackWord *lyric;		ȥåβλ
 *	֤
 *		NULLʳ	λʸʲλꥹ/NULLݥ󥿽ü
 *	
 *		λ¸ߤʤϡԤΤߤ"Empty" Ƚ񤫤줿֤
 *		
 *		֤
 *		
 *		
 *		ܤؤΥݥ󥿨 "??:??:??   ܤβλ"
 *		
 *		ܤؤΥݥ󥿨 "??:??:??   ܤβλ"
 *		
 *		
 *		
 *		
 *		
 *		ǽԤؤΥݥ󥿨 "??:??:??   ǽԤβλʶԤ"
 *		
 *		   NULLݥ   
 *		
 *		
 ***************************************************************************/
char **makeWords(TrackWord *lyric)
{
	int counter;
	int lines;
	char **words_ptr_ptr = NULL;
	char *wordsEmpty = "Empty";
	char wordLine[1024];

	lines = wordCount(lyric);
	if(lines > 0) {
		words_ptr_ptr = (char**)malloc(sizeof(*words_ptr_ptr) * (lines + 1));
		if(words_ptr_ptr != NULL) {
			for(counter = 0;lyric != NULL;
								lyric = lyric->next_ptr,++counter) {
				if(lyric->wordTime.minute != 255) {
					snprintf(wordLine, sizeof(wordLine), "%2d:%02d:%02d   %s", 
						lyric->wordTime.minute, lyric->wordTime.second, 
						lyric->wordTime.frame, lyric->word);
				} else {
					snprintf(wordLine, sizeof(wordLine), 
							"--:--:--   %s", lyric->word);
				}
				*(words_ptr_ptr + counter) = 
									(char*)malloc(strlen(wordLine) + 1);
				if(*(words_ptr_ptr + counter) != NULL) {
					strcpy(*(words_ptr_ptr + counter), wordLine);
				}
			}
			*(words_ptr_ptr + counter) = NULL;
		}
	} else {
		words_ptr_ptr = (char**)malloc(sizeof(*words_ptr_ptr) * 2);
		if(words_ptr_ptr != NULL) {
			*words_ptr_ptr = (char*)malloc(strlen(wordsEmpty) + 1);
			if(*words_ptr_ptr != NULL) {
				strcpy(*words_ptr_ptr, wordsEmpty);
			}
			*(words_ptr_ptr + 1) = NULL;
		}
	}
	return(words_ptr_ptr);
}

/***************************************************************************
 *	wordStringOut: λǡʸФ
 *	
 *		unsigned const char *wordStringOut(const void *stringInfo);
 *	
 *		const void *stringInfo;
 *	֤
 *		NULL:		λǡνüãʸФʤ
 *		NULLʳ:	λǡФʸؤݥ
 *	
 *		δؿϡλǡƬβλʸФޤ
 *		ԡλǡ˲λǡؤݥ󥿤̵ʤ뤫
 *		λǡ˲λǡؤݥ̵ NULL ֤
 *		
 *		ºݤβλǡϡθƤӽФΤȤʳϡԡλǡ
 *		ƤӽФޤ
 *		ʤνϡwordNextString() ǹԤޤ
 *		ʤ顢δؿǤϡ˴طʤλǡλؤǽ
 *		λǡФ
 *		ĤޤꡢΤȤϡºݤβλǡѤΤǡǽβλ줬
 *		Ф롣
 *		ܰʹߤϡԡλǡβλ줬Ƭβλˤʤ
 *		˲ѤƤΤǡδؿǤϡͤƬβλμ
 *		Фޤ
 *		
 *		
 *		
 *		λؤΥݥ󥿣ΨλλĢNULL
 *		
 *		
 *		
 *		λؤΥݥ󥿣بλĢλNULL
 *		
 *		λǡι¤Ρ˨
 *		
 *		
 *		
 *		ԡλǡ
 *		
 *		λؤݥ󡡨
 *		
 *		λؤΥݥ󥿣NULL
 *		
 *		NULL
 *		
 *		λؤΥݥ󥿣ΨġĨ
 *		
 *		βλإݥ󥿤ܤ
 *		
 *		λؤΥݥ󥿣ب
 *		
 *		
 *		
 *		
 *		λԿĥǥιԿ
 *		
 *		ǥΥȥåĲλΥݥο
 *		
 *		λؤΥݥ󥿤Υݥ󥿨ĥȥåʬΥݥ
 *		
 *		λǡ¤ΡdiscWords ѿ
 *		
 *		
 *		ƬβλμΡ٤ϡλؤݥΤͭʥݥ
 *		󥿤ͭʥݥ󥿤ƬõߤĤʲηι¤Τ顢
 *		
 *		λƬ
 *		
 *		ɽϻ֨оݡ
 *		
 *		λʣԡ˨ʸ󨭨
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		
 *		
 *		
 *		
 *		λʸʢˤФޤ
 *		
 ***************************************************************************/
unsigned const char *wordStringOut(const void *stringInfo)
{
	int counter;
	const char *string_ptr = NULL;
	DiscWord *discWord = (DiscWord*)stringInfo;

	if(discWord != NULL) {
		for(counter = 0;*(discWord->trackWords + counter) == NULL && 
									counter < discWord->tracks;++counter)
			;		/* 롼 */
		if(counter < discWord->tracks && 
						*(discWord->trackWords + counter) != NULL) {
			/* ͭʲλƬĤä */
			string_ptr = (*(discWord->trackWords + counter))->word;
		}
	}
	return(string_ptr);
}

/***************************************************************************
 *	wordNextString: βλؤ¤ΤϤ
 *	
 *		const void *wordNextString(const void *stringInfo);
 *	
 *		const void *stringInfo;		λؤΥݥ
 *	֤
 *		NULL			ã
 *		NULLʳ		ιԤؤλ
 *	
 *		ιԤؤλ
 *		
 *		δؿϡʲΤ褦ʽ򤷤ޤ
 *		
 *		1.λǡΡزλؤݥ٤ȡزλǡ¤Ρ
 *		ʬ򥳥ԡ롣ʲλΤϥԡʤ޻ȡ
 *		νϡǽˤδؿƤӽФ줿硢
 *		ĤޤꡢstringInfo  &discWords ΤȤΤߤǤ
 *		
 *		ǽϤ줿 stringInfo μ
 *		
 *		λǡ¤Ρ
 *		
 *		λԿĥǥιԿ
 *		
 *		ǥΥȥåĲλΥݥο
 *		
 *		λؤΥݥ󥿤Υݥ󥿨ĥȥåʬΥݥ
 *		
 *		
 *		
 *		
 *		λؤΥݥ󥿣λĢλNULL
 *		
 *		λؤΥݥ󥿣 NULL ݥ󥿡
 *		
 *		ġ
 *		
 *		λؤΥݥ󥿣بλĢλNULL
 *		
 *		λǡι¤Ρ˨
 *		
 *		
 *		
 *		ԡλǡ
 *		
 *		λؤݥ󡡨
 *		
 *		λؤΥݥ󥿣
 *		
 *		λؤΥݥ󥿣
 *		
 *		
 *		
 *		λؤΥݥ󥿣ب
 *		ġġġXtMalloc() ǳݤ 
 *		
 *		
 *		
 *		λԿĥǥιԿ
 *		
 *		ǥΥȥåĲλΥݥο
 *		
 *		λؤΥݥ󥿤Υݥ󥿨ĥȥåʬΥݥ
 *		
 *		λǡ¤ΡdiscWords ѿ
 *		
 *		
 *		2.βλؤΰư
 *		ԡλؤݥ󥿤ǡǤβλؤΥݥ󥿤
 *		βλذư롣
 *		
 *		
 *		
 *		λؤΥݥ󥿣ΨλλĢNULL
 *		
 *		
 *		
 *		λؤΥݥ󥿣بλĢλNULL
 *		
 *		λǡι¤Ρ˨
 *		
 *		
 *		
 *		ԡλǡ
 *		
 *		λؤݥ󡡨
 *		
 *		λؤΥݥ󥿣ΨĨ
 *		
 *		βλإݥ󥿤ܤ
 *		
 *		λؤΥݥ󥿣ب
 *		
 *		
 *		
 *		
 *		λԿĥǥιԿ
 *		
 *		ǥΥȥåĲλΥݥο
 *		
 *		λؤΥݥ󥿤Υݥ󥿨ĥȥåʬΥݥ
 *		
 *		λǡ¤ΡdiscWords ѿ
 *		
 *		
 *		3.βλ줬̵ʤäȤdiscWords.trackWords ƤNULL
 *		λؤݥ XtFree() ǲ
 *		discWords ѿ 0x00 롣
 *		
 *		ԡλǡ
 *		
 *		λؤݥ󡡡
 *		
 *		λؤΥݥ󥿣NULL
 *		
 *		λؤΥݥ󥿣NULL
 *		
 *		
 *		
 *		λؤΥݥ󥿣بNULL
 *		ġġġXtFree() ǳݤ 
 *		ġġġ0x00롡
 *		
 *		
 *		λԿĥǥιԿ
 *		
 *		ǥΥȥåĲλΥݥο
 *		
 *		λؤΥݥ󥿤Υݥ󥿨ĥȥåʬΥݥ
 *		
 *		λǡ¤ΡdiscWords ѿ
 *		
 *		
 *		
 ***************************************************************************/
const void *wordNextString(const void *stringInfo)
{
	int counter;
	size_t trackSize;
	static DiscWord discWords;
	TrackWord **trackWords;
	const DiscWord *result = NULL;
	const DiscWord *discWords_ptr = (const DiscWord*)stringInfo;

	if(discWords_ptr != &discWords) {
		if(discWords_ptr != NULL) {
			/*************************************************************
			 *	λǡν
			 *		λǡΥԡ/ݥκԡ
			 *************************************************************/
			discWords  = *discWords_ptr;
			trackSize  = discWords.tracks * sizeof(*trackWords);
			discWords.trackWords = trackWords = 
										(TrackWord**)XtMalloc(trackSize);
			if(trackWords != NULL) {
				memcpy(trackWords, discWords_ptr->trackWords, trackSize);
			}
		} else {
			return(NULL);
		}
	}
	if(discWords_ptr != NULL) {
		for(counter = 0;*(discWords.trackWords + counter) == NULL &&
									counter < discWords.tracks;++counter)
			;		/* 롼 */
		if(counter < discWords.tracks && 
							*(discWords.trackWords + counter) != NULL) {
			/*****************************************************
			 *	ԡλǡݥ󥿤ʤ
			 *****************************************************/
			*(discWords.trackWords + counter) = 
						(*(discWords.trackWords + counter))->next_ptr;
			result = &discWords;
		} else {
			/*****************************************************
			 *	ԡλǡ˴
			 *		λؤݥ XtFree() ǳݤ
			 *		discWords ѿ 0x00 
			 *****************************************************/
			XtFree((char*)discWords.trackWords);
			memset(&discWords, 0x00, sizeof(discWords));
		}
	}
	return(result);
}

