/***************************************************************************
 *	cdda_iox.c - X11R6 CD player I/O 桼ƥƥؿ
 *										for mwxcd Version 1.30
 *	
 *			Date 1998/10/31 -- 
 *					Programmed by Nobuyuki Maruichi
 *	
 *		ˡС򰷤
 *	ª
 *		ܸ EUC
 *		Tab Size 4 / Shift Width = 4
 *		
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Core.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

/**************************************
 * mwxcd ѤΥ󥯥롼ɡե
 **************************************/
#include "stringuty.h"
#include "cdda_ioc.h"
#include "mwxcd.h"
#ifdef	TOWNS
# include <linux/towns_cdioc.h>
#else
# include "towns_cdda.h"
#endif	/* TOWNS */

static const String MwxcdNwrongParameters = "wrongParameters";

/* from /xc/lib/Xt/Converters.c and X Toolkit Intrinsics Reference Manual. */
#define	done(type, value) \
	{							\
	    if (toVal->addr != NULL) {				\
		if (toVal->size < sizeof(type)) {		\
		    toVal->size = sizeof(type);			\
		    return False;				\
		}						\
		*(type*)(toVal->addr) = (value);		\
	    }							\
	    else {						\
		static type static_val;				\
		static_val = (value);				\
		toVal->addr = (XPointer)&static_val;		\
	    }							\
	    toVal->size = sizeof(type);				\
	    return True;					\
	}

/***************************************************************************
 *	CddaIoTypeConverter: ʸ󤫤 CDDA  ioctl() ˤˡѴ
 *	
 *		Boolean CddaIoTypeConverter(Display *dpy, 
 *			XrmValue *args, Cardinal *num_args, 
 *			XrmValue *fromVal, XrmValue *toVal, XtPointer *converter_data);
 *	
 *		Display *dpy;			ѴԤǥץ쥤
 *		XrmValue *args;			СФɲäΰ̤ѡ
 *		Cardinal *num_args;		args ΰο
 *		XrmValue *fromVal;		СȤ븵ͤΥɥ쥹礭
 *		XrmValue *toVal;		СȤͤΥɥ쥹礭
 *		XtPointer *converter_data;	̤ѡ
 *	֤
 *		False:		Ѵ˼
 *		True:		Ѵ
 *	
 *		
 ***************************************************************************/
Boolean CddaIoTypeConverter(Display *dpy, XrmValue *args, Cardinal *num_args, 
				XrmValue *fromVal, XrmValue *toVal, XtPointer *converter_data)
{
	int result = EOF;	/* ϡioType  */
	String target = (String)fromVal->addr;
	static const char *ioTypeNames[] = {"TownsOld", "TownsExt", "GENERAL", NULL};

	if(*num_args != 1) {
		result = searchInStringPointerArray(target, ioTypeNames, asciiStringCaseCmp);
		if(result == EOF && asciiStringCaseCmp(target, "TOWNS")) {
			result = TownsIO;
		}
	}
	if(result == EOF) {
		XtAppWarningMsg(XtDisplayToApplicationContext(dpy),
				MwxcdNwrongParameters, "CddaIoTypeConverter", XtCCdIoctl,
							"Cannot conver string to CDDA I/O type",
										(String *)NULL, (Cardinal *)NULL);
		return(False);
	}
	done(int, result);
}

