/***************************************************************************
 *	luty.c: Locale 桼ƥƥ
 *	
 *		Date. 1997/08/07 -- 
 *			Programed by Nobuyuki Maruichi
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>

/***********************************************
 *	ѤΥ󥯥롼ɡե
 ***********************************************/
#include "luty.h"
#include "stringuty.h"

#define	 min(a,b)		(((a)<(b))?(a):(b))

#ifdef	TEST
int verbose = 0;
int maxLength = 0;
char *fileName;
char **encodeName;
#define max(a, b)	((a > b)?(a):(b))
#endif /*TEST*/

/***************************************************************************
 *	skipSpace: Ϣ³ʸʥ֡Ԥޤˤ
 *	
 *		int skipSpace(const char *line);
 *	
 *		const char *line;	ʸ򥫥Ȥʸ
 *	֤
 *		Ϣ³ʸʥ֡Ԥޤˤ
 *	
 *		
 ***************************************************************************/
int skipSpace(const char *line)
{
	int counter;

	for(counter = 0;line != NULL && *(line + counter) != '\0' && 
									isspace(*(line + counter));++counter)
		;			/*  */
	return(counter);
}

/***************************************************************************
 *	messageAlloc: ʬĥ꡼ΥΡɤݤ
 *	
 *		MessageNode *messageAlloc(const char *line);
 *	
 *		const char *line;		åʸ
 *	֤
 *		NULL:		åγݤ˼
 *		NULLʳ:	ݤå
 *	
 *		
 ***************************************************************************/
MessageNode *messageAlloc(const char *line)
{
	int mesLength;
	int keyLength;
	char buffer[256];
	const char *nextMessage;
	const char *messString;
	MessageNode *alloc_ptr = NULL;

	messString = strchr(line, ':');
	nextMessage = strchr(line, '\n');
	if(nextMessage == NULL) {
		nextMessage = line + strlen(line);
	}
	if(messString != NULL && nextMessage != NULL) {
		keyLength = messString - line;
		mesLength = nextMessage - messString - 1;
		if(keyLength > 0 && mesLength > 0) {
			sprintf(buffer, "%.*s", 
				(int)min(keyLength, sizeof(buffer)-1), line);
			alloc_ptr = (MessageNode*)XtMalloc(sizeof(MessageNode));
			alloc_ptr->keyword = XtNewString(buffer + skipSpace(buffer));
			sprintf(buffer, "%.*s", 
					(int)min(mesLength, sizeof(buffer)-1), messString+1);
			alloc_ptr->message = XtNewString(buffer);
			alloc_ptr->lowerLink  = NULL;
			alloc_ptr->higherLink = NULL;
			/*printf("***%s***%s***\n", alloc_ptr->keyword, alloc_ptr->message);*/
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	messageLink: ʬĥ꡼ΥΡɤؤϿԤ
 *	
 *		MessageNode *messageLink(MessageNode **node, MessageNode *newMess);
 *	
 *		MessageNode **node;		ĥ꡼ˤʤäƤΡ
 *		MessageNode *newMess;	Ρ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void messageLink(MessageNode **node, MessageNode *newMess)
{
	int result;

	if(*node == NULL) {
		*node = newMess;
	} else {
		result = strcmp((*node)->keyword, newMess->keyword);
		if(result != 0) {
			if(result > 0) {
				messageLink(&(*node)->lowerLink, newMess);
			} else {
				messageLink(&(*node)->higherLink, newMess);
			}
		} else {
			XtFree((char*)newMess->keyword);
			XtFree((char*)newMess->higherLink);
			XtFree((char*)newMess);
		}
	}
	return;
}

/***************************************************************************
 *	linelength: åĹ
 *	
 *		int linelength(const char *line);
 *	
 *		const char *line;	åʸ'\n'ˤޤ
 *	֤
 *		åĹ
 *	
 *		
 ***************************************************************************/
int linelength(const char *line)
{
	int length = 0;
	const char *nextLine;

	nextLine = strchr(line, '\n');
	if(nextLine == NULL) {
		length = strlen(line);
	} else {
		length = nextLine - line + 1;
	}
	return(length);
}

/***************************************************************************
 *	makeMessages: åʸ򥭡ɤ鸡ǽʼˤ
 *	
 *		MessageNode *makeMessages(const char *messages);
 *	
 *		MessageNode *topMess;	ɲäΡɡʿΤȤϡNULL
 *		const char *messages;	åʸ'\n'ˤޤ
 *	֤
 *		NULL:		ι˼
 *		NULLʳ:	åʬĥ꡼
 *	
 *		åʸ򥭡ɤ鸡ǽʼˤ롣
 *		kˡ
 *		1 ¸Τ򥭡ɸɲäϡ topMess ˴
 *			¸Τꤹ롣
 *		2 Υɼϡ topMess  NULL 
 *			ꤹ롣
 ***************************************************************************/
MessageNode *makeMessages(MessageNode *topMess, const char *messages)
{
	const char *line;
	MessageNode *newMess = NULL;

	for(line = messages;
			line != NULL && *line != '\0';line += linelength(line)) {
		newMess = messageAlloc(line);
		if(newMess != NULL) {
			messageLink(&topMess, newMess);
		} else {
			printf("newMess is NULL\n");
		}
	}
	return(topMess);
}

/***************************************************************************
 *	printTree: ǥХåѤˣʬĥ꡼ɽ
 *	
 *		void printTree(MessageNode *node);
 *	
 *		MessageNode *node;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void printTree(MessageNode *node)
{
	if(node == NULL)
		return;
	printTree(node->lowerLink);
	printf("%s:%s\n", node->keyword, node->message);
	printTree(node->higherLink);
}

/***************************************************************************
 *	messageSearch: ʬĥ꡼ꤵ줿ɤǸ
 *	
 *		MessageNode *messageSearch(const MessageNode *node, const char *keyword);
 *	
 *		const MessageNode *node;	ʬĥ꡼κȡʸϰ֡
 *		const char *keyword;		
 *	֤
 *		NULL:		ꤵ줿ɤĤʤä
 *		NULLʳ:	ꤵ줿ɤޤΥΡ
 *	
 *		
 ***************************************************************************/
const MessageNode *messageSearch(const MessageNode *node, const char *keyword)
{
	int status;
	const MessageNode *result_ptr = NULL;

	if(node != NULL && node->keyword != NULL && keyword != NULL) {
		status = strcmp(node->keyword, keyword);
		switch(status) {
		case 0:
			result_ptr = node;
			break;
		default:
			if(status > 0) {
				result_ptr = messageSearch(node->lowerLink, keyword);
			} else {
				result_ptr = messageSearch(node->higherLink, keyword);
			}
			break;
		}
	}
	return(result_ptr);
}

/***************************************************************************
 *	jis2sjis: JIS X0208-1983/1990 ɤ SHIFT JIS ɤѴ
 *	
 *		unsigned int jis2sjis(unsigned int c);
 *	
 *		unsigned int c;		JIS X0208-1983/1990 ɡ16bit
 *	֤
 *		SHIFT JIS 
 *	
 *		
 ***************************************************************************/
unsigned int jis2sjis(unsigned int c)
{
	unsigned int high = ((c >> 8) & 0x00ff);
	unsigned int low  = (c & 0x00ff);

	low += ((high & 0x0001)?(0x1f):(0x7d));
	high = ((high - 0x21) >> 1) + 0x81;
	low += (low >= 0x7f);
	if(high > 0x9f)
		high += 0x40;
	return(high << 8 | low);
}

/***************************************************************************
 *	sjis2jis: SHIFT JIS ɤ JIS X0208-1983/1990 ɤѴ
 *	
 *		unsigned int sjis2jis(unsigned int c);
 *	
 *		unsigned int c;		SHIFT JIS 
 *	֤
 *		JIS X0208-1983/1990 
 *	
 *		
 ***************************************************************************/
unsigned int sjis2jis(unsigned int c)
{
	unsigned int high = ((c >> 8) & 0x00ff);
	unsigned int low  = (c & 0x00ff);

	high -= ((high <= 0x9f)?(0x71):(0xb1));
	high  = (high * 2) + 1;
	low  -= (low > 0x7f);
	if(low >= 0x9e) {
		low  -= 0x7d;
		++high;
	} else {
		low  -= 0x1f;
	}
	return(high << 8 | low);
}

/***************************************************************************
 *	euc2jis: ܸ EUC ɤ JIS ɤѴ
 *	
 *		unsigned int euc2jis(unsigned int c);
 *	
 *		unsigned int c;		1/2/3 Хȣʸܸ EUC 
 *	֤
 *		JIS X0201/JIS X0208/JIS X0212 
 *	
 *		
 ***************************************************************************/
unsigned int euc2jis(unsigned int c)
{
	int type;
	int result = 0;		/* Ȥꤢ */

	type = (((c >> 16) == SS3)?(JISX0212):
						(((c >> 8) == SS2)?(JISX0201):
									((c < 0x80)?(ISO_8859):(JISX0208))));
	switch(type) {
	case ISO_8859:
		result = c & 0x7f;
		break;
	case JISX0201:
		result = c & 0xff;
		break;
	case JISX0208:
	case JISX0212:
		result = c & 0x7f7f;
		break;
	}
	return(result);
}

/***************************************************************************
 *	jis2euc: JIS X0208-1983/1990 ɤܸ EUC ɤѴ
 *	
 *		unsigned int jis2euc(unsigned int c);
 *	
 *		unsigned int c;		JIS X0208-1983/1990 
 *	֤
 *		ܸ EUC ɡ2bytes
 *	
 *		
 ***************************************************************************/
unsigned int jis2euc(unsigned int c)
{
	return(c | 0x8080);
}

/***************************************************************************
 *	codesetJis: JIS ʸ󤫤ƬʸʸȥɤФޤ
 *	
 *		int codesetJis(unsigned const char **src_ptr, int old, int *type);
 *	
 *		unsigned const char **src_ptr;	ʸؤΥݥ
 *		int old;		ľʸʸʸåȼѤμ̻ҡ
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *		int *type;		ƬʸʸʸåȼѤμ̻ҡˤ֤
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *	֤
 *		Ƭʸʸ
 *		ISO 8859  ξ:	0x000x7f
 *		JIS X0201 ξ:	0xa00xff
 *		JIS X0208 ξ:	0x21210x7f7f
 *		JIS X0212 ξ:	0x21210x7f7f
 *	
 *		ʸ󤫤Ƭʸʸ򡢤ʸμ̡ISO8859(ASCII)/
 *		JIS X0201ȾѤʡ/JIS X0208JIS/JIS X0212JISˡ
 *		ξȶ˼Фޤ
 *	Ȼ
 *		ʸåȼѤμ̻ҡluty.h
 *		
 ***************************************************************************/
int codesetJis(unsigned const char **src_ptr, int old, int *type)
{
	int code = **src_ptr;
	int length;
	int counter;
	const char *sequence;
	static const struct {
		const char *escSequence;
		const int  codeSet;
	} codeInfo[] = {
		{"\x1B\x26\x40\x1B\x24\x42", JISX0208}, 
		{"\x1B\x24\x28\x44",         JISX0212}, 
		{"\x1B\x24\x42",             JISX0208}, 
		{"\x1B\x28\x49",             JISX0201}, 
		{"\x1B\x28\x42",             ISO_8859}, 
		{"\x1B\x28\x48",             ISO_8859}, 
		{"\x1B\x28\x4A",             ISO_8859}, 
		{NULL,                       ISO_8859}
	};

	while((code = **src_ptr) == '\x1b') {
		for(counter = 0;codeInfo[counter].escSequence != NULL;++counter) {
			sequence = codeInfo[counter].escSequence;
			length = strlen(sequence);
			if(strncmp(sequence, *src_ptr, length) == 0) {
				*src_ptr += length;
				*type = codeInfo[counter].codeSet;
				break;
			}
		}
		*src_ptr += (codeInfo[counter].escSequence == NULL);
	}
	if(*type == ISO_8859) {
		*type = ((code < 0x80)?(ISO_8859):(JISX0201));
	}
	switch(*type) {
	default:
	case ISO_8859:
		code = **src_ptr & 0x7f;
		++*src_ptr;
		break;
	case JISX0201:
		code = **src_ptr | 0x80;
		++*src_ptr;
		break;
	case JISX0212:
	case JISX0208:
		code = **src_ptr;
		code <<= 8;
		code |= *(*src_ptr + 1);
		code &= 0x7f7f;
		*src_ptr += 2;
		break;
	}
	return(code);
}

/***************************************************************************
 *	codesetSjis: SJIS ʸ󤫤ƬʸʸȥɤФޤ
 *	
 *		int codesetSjis(unsigned const char **src_ptr, int old, int *type);
 *	
 *		unsigned const char **src_ptr;	ʸ
 *		int old;		ľʸʸʸåȼѤμ̻ҡ
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *		int *type;		ƬʸʸʸåȼѤμ̻ҡˤ֤
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *	֤
 *		Ƭʸʸ
 *		ISO 8859  ξ:	0x000x7f
 *		JIS X0201 ξ:	0xa00xff
 *		JIS X0208 ξ:	0x21210x7f7f
 *		JIS X0212 ξ:	0x21210x7f7f
 *	
 *		ʸ󤫤Ƭʸʸ򡢤ʸμ̡ISO8859(ASCII)/
 *		JIS X0201ȾѤʡ/JIS X0208JIS/JIS X0212JISˡ
 *		ξȶ˼Фޤ
 *	Ȼ
 *		ʸåȼѤμ̻ҡluty.h
 *		
 ***************************************************************************/
int codesetSjis(unsigned const char **src_ptr, int old, int *type)
{
	int code;
	int code0 = **src_ptr;
	int code1 = *(*src_ptr + 1);

	if(((code0 >= 0x81 && code0 <= 0x9f) || (code0 >= 0xe0 && code0 <=  0xfc))
					&& (code1 >= 0x40 && code1 <= 0xfc && code1 != 0x7f)) {
		*type = JISX0208;
	} else {
		*type = ((code0 < 0x80)?(ISO_8859):(JISX0201));
	}
	switch(*type) {
	default:
	case ISO_8859:
	case JISX0201:
		code = **src_ptr;
		++*src_ptr;
		break;
	case JISX0212:
	case JISX0208:
		code = (code0 << 8) | code1;
		code = sjis2jis(code);
		code &= 0x7f7f;
		*src_ptr += 2;
		break;
	}
	return(code);
}

/***************************************************************************
 *	codesetEuc: EUC ʸ󤫤ƬʸʸȥɤФޤ
 *	
 *		int codesetEuc(unsigned const char **src_ptr, int old, int *type);
 *	
 *		unsigned const char **src_ptr;	ʸ
 *		int old;		ľʸʸʸåȼѤμ̻ҡ
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *		int *type;		ƬʸʸʸåȼѤμ̻ҡˤ֤
 *						ISO_8859/JISX0201/JISX0208/JISX0212 Τ줫
 *	֤
 *		Ƭʸʸ
 *		ISO 8859  ξ:	0x000x7f
 *		JIS X0201 ξ:	0xa00xff
 *		JIS X0208 ξ:	0x21210x7f7f
 *		JIS X0212 ξ:	0x21210x7f7f
 *	
 *		ʸ󤫤Ƭʸʸ򡢤ʸμ̡ISO8859(ASCII)/
 *		JIS X0201ȾѤʡ/JIS X0208JIS/JIS X0212JISˡ
 *		ξȶ˼Фޤ
 *	Ȼ
 *		ʸåȼѤμ̻ҡluty.h
 *		
 ***************************************************************************/
int codesetEuc(unsigned const char **src_ptr, int old, int *type)
{
	int code = **src_ptr;

	*type = ((code < 0x80)?(ISO_8859):(JISX0208));
	*type += (code == SS3) - (code == SS2);
	switch(*type) {
	default:
	case ISO_8859:
		++*src_ptr;
		break;
	case JISX0201:
		++*src_ptr;
		code = **src_ptr;
		++*src_ptr;
		break;
	case JISX0212:
		code = *++*src_ptr;
		/* ʲν³ */
	case JISX0208:
		code <<= 8;
		code |= *(*src_ptr + 1);
		code &= 0x7f7f;
		*src_ptr += 2;
		break;
	}
	return(code);
}

/***************************************************************************
 *	encodeJis1: ꤵ줿ʸΥɤJISʸХåե˽񤭽Фޤ
 *	
 *		int encodeJis(unsigned char *dest_ptr, int code, old, type);
 *	
 *		unsigned char *dest_ptr;	ѴʸǼХåե
 *		int code;		ʸ
 *		int old;		ľʸʸ
 *		int type;		ɤʸ
 *	֤
 *		Хåե˳Ǽʸ
 *	
 *		ꤵ줿ʸΥɤJISʸХåե˽񤭽Фޤ
 *		 dest_ptr  NULL ǤϡʸѴϹԤ鷺ʸΥȤΤߤ
 *		Ԥ
 ***************************************************************************/
int encodeJis1(unsigned char *dest, int code, int old, int type)
{
	size_t counter = 0;
	static const char *escSequence[4] = {
		"\x1b\x28\x42", "\x1b\x28\x49", "\x1b\x24\x42", "\x1b\x24\x28\x44"
	};

	if(old != type) {
		counter = strlen(escSequence[type]);
		if(dest != NULL) {
			sprintf(dest, "%s", escSequence[type]);
			dest += counter;
		}
	}
	switch(type) {
	case ISO_8859:
	case JISX0201:
		code &= 0x7f;
		if(dest != NULL) {
			dest += sprintf(dest, "%c", code);
		}
		++counter;
		break;
	case JISX0208:
	case JISX0212:
		if(dest != NULL) {
			dest += sprintf(dest, "%c%c", (code >> 8), (code & 0xff));
		}
		counter += 2;
		break;
	}
	return(counter);
}

/***************************************************************************
 *	encodeJis2: ꤵ줿ʸΥɤJISʸХåե˽񤭽Фޤ
 *	
 *		int encodeJis(unsigned char *dest_ptr, int code, old, type);
 *	
 *		unsigned char *dest_ptr;
 *		int code;		ʸ
 *		int old;		ľʸʸ
 *		int type;		ɤʸ
 *	֤
 *		Хåե˳Ǽʸ
 *	
 *		
 *		 dest_ptr  NULL ǤϡʸѴϹԤ鷺ʸΥȤΤߤ
 *		Ԥ
 ***************************************************************************/
int encodeJis2(unsigned char *dest, int code, int old, int type)
{
	size_t counter = 0;
	static const char *escSequence[4] = {
		"\x1b\x28\x42", "\x1b\x28\x49", "\x1b\x24\x42", "\x1b\x24\x28\x44"
	};

	if(old == JISX0201) {
		/*	JIS X0201ȾѤʡˤϡISO-8859-1(Latin-1)Ȥߤʤ */
		old = ISO_8859;
	}
	if(type == JISX0201) {
		/*	JIS X0201ȾѤʡˤϡISO-8859-1(Latin-1)Ȥߤʤ */
		type = ISO_8859;
	}
	if(old != type) {
		counter = strlen(escSequence[type]);
		if(dest != NULL) {
			counter = sprintf(dest, "%s", escSequence[type]);
			dest += counter;
		}
	}
	switch(type) {
	case ISO_8859:
	case JISX0201:
		if(dest != NULL) {
			dest += sprintf(dest, "%c", code);
		}
		++counter;
		break;
	case JISX0208:
	case JISX0212:
		if(dest != NULL) {
			dest += sprintf(dest, "%c%c", (code >> 8), (code & 0xff));
		}
		counter += 2;
		break;
	}
	return(counter);
}

/***************************************************************************
 *	encodeSjis: ꤵ줿ʸΥɤSJISʸХåե˽񤭽Фޤ
 *	
 *		int encodeSjis(unsigned char *dest_ptr, int code, old, type);
 *	
 *		unsigned char *dest_ptr;	ѴʸǼХåե
 *		int code;		ʸ
 *		int old;		ľʸʸ
 *		int type;		ɤʸ
 *	֤
 *		Хåե˳Ǽʸ
 *	
 *		ꤵ줿ʸΥɤSJISʸХåե˽񤭽Фޤ
 *		 dest_ptr  NULL ǤϡʸѴϹԤ鷺ʸΥȤΤߤ
 *		Ԥ
 ***************************************************************************/
int encodeSjis(unsigned char *dest, int code, int old, int type)
{
	size_t counter = 0;

	switch(type) {
	case ISO_8859:
	case JISX0201:
		if(dest != NULL) {
			*dest = code;
			*(dest+1) = '\0';
		}
		counter = 1;
		break;
	case JISX0212:
		/* Not suppoertted */
		break;
	case JISX0208:
		if(dest != NULL) {
			code = jis2sjis(code);
			dest += sprintf(dest, "%c%c", (code >> 8), (code & 0xff));
		}
		counter = 2;
		break;
	}
	return(counter);
}

/***************************************************************************
 *	encodeEuc: ꤵ줿ʸΥɤEUCʸХåե˽񤭽Фޤ
 *	
 *		int encodeEuc(unsigned char *dest_ptr, int code, old, type);
 *	
 *		unsigned char *dest_ptr;	ѴʸǼХåե
 *		int code;		ʸ
 *		int old;		ľʸʸ
 *		int type;		ɤʸ
 *	֤
 *		Хåե˳Ǽʸ
 *	
 *		ꤵ줿ʸΥɤEUCʸХåե˽񤭽Фޤ
 *		 dest_ptr  NULL ǤϡʸѴϹԤ鷺ʸΥȤΤߤ
 *		Ԥ
 ***************************************************************************/
int encodeEuc(unsigned char *dest, int code, int old, int type)
{
	size_t counter = 0;

	switch(type) {
	case JISX0201:
		if(dest != NULL) {
			*dest = SS2;
			++dest;
		}
		++counter;
		/* ʲν³ */
	case ISO_8859:
		if(dest != NULL) {
			*dest = code;
			++dest;
			*dest = '\0';
		}
		++counter;
		break;
	case JISX0212:
		if(dest != NULL) {
			*dest = SS3;
			++dest;
		}
		++counter;
		/* ʲν³ */
	case JISX0208:
		if(dest != NULL) {
			code |= 0x8080;
			dest += sprintf(dest, "%c%c", (code >> 8), (code & 0xff));
		}
		counter += 2;
		break;
	}
	return(counter);
}

/***************************************************************************
 *	string2otherCodeset: ʸ¾ΥɤѴ
 *	
 *		int string2otherCodeset(char *destTop, size_t length, 
 *			const char *srcTop, CodesetProc codeset, EncodeProc encode);
 *	
 *		char *destTop;			ѴʸǼХåե
 *		size_t length;			ѴʸǼХåեθ³
 *		const char *srcTop;		ʸ
 *		CodesetProc codeset;	ʸ󤫤ʸȥɤμؿ
 *		EncodeProc encode;		ʸȥɤѴʸ
 *	֤
 *		EOF		ѴԲǽʾ
 *		0ʾ塧		Ѵ줿ʸ
 *	
 *		ʸ¾ΥɤѴ
 *		 destTop  NULL ǤϡʸѴϹԤ鷺ʸΥȤΤߤ
 *		Ԥ
 *		
 *		 codeset() ϡºݤˤϰʲηδؿؤΥݥ󥿤Ǥ
 *		int (*codeset)(unsigned const char **src_ptr, int old, int *type);
 *						
 *		 encode() ϡºݤˤϰʲηδؿؤΥݥ󥿤Ǥ
 *		int (*encode)(unsigned char *dest_ptr, int code, int old, int type);
 *		
 ***************************************************************************/
int string2otherCodeset(char *destTop, size_t length, 
				const char *srcTop, CodesetProc codeset, EncodeProc encode)
{
	int code;
	int type = 0;
	int old = 0;
	int counter = 0;
	int stepCounter = 1;		/* Ȥꤢ */
	char buffer[10];
	const unsigned char *src = srcTop;
	unsigned char *dest = destTop;

	if(codeset == NULL || encode == NULL) {
		return(EOF);
	}
	if(destTop != NULL)
		*destTop = '\0';
	while((destTop == NULL || counter < length) && src != NULL && *src != '\0') {
		code = codeset(&src, old, &type);
		stepCounter = 
				encode(((dest != NULL)?(buffer):(NULL)), code, old, type);
		old = type;
		if(destTop == NULL || counter + stepCounter < length) {
			if(destTop != NULL) {
				strcat(destTop, buffer);
			}
			counter += stepCounter;
		}
	}
	if(destTop == NULL || counter + stepCounter < length) {
		stepCounter = 
			encode(((dest != NULL)?(buffer):(NULL)), '\0', old, ISO_8859);
		if(destTop != NULL) {
			strcat(destTop, buffer);
		}
		counter += stepCounter;
	}

	return(counter);
}

/***************************************************************************
 *	streamConvert: ե뤫ɤ߹ʸ̥ɤɸϤ
 *	
 *		void streamConvert(FILE *fp, CodesetProc codeset, EncodeProc encode);
 *	
 *		FILE *fp;	եݥ
 *		CodesetProc codeset;	ʸ󤫤ʸȥɤμؿ
 *		EncodeProc encode;		ʸȥɤѴʸ
 *	֤
 *		
 *	
 *		 codeset() ϡºݤˤϰʲηδؿؤΥݥ󥿤Ǥ
 *		int (*codeset)(unsigned const char **src_ptr, int old, int *type);
 *						
 *		 encode() ϡºݤˤϰʲηδؿؤΥݥ󥿤Ǥ
 *		int (*encode)(unsigned char *dest_ptr, int code, int old, int type);
 *		
 ***************************************************************************/
void streamConvert(FILE *fp, CodesetProc codeset, EncodeProc encode)
{
	char *readTop;
	char iBuffer[8192];
	char oBuffer[8192];

	do {
		readTop = fgets(iBuffer, sizeof(iBuffer), fp);
		if(readTop != NULL) {
			/*printf("old:%s", iBuffer);*/
			string2otherCodeset(oBuffer, 
					sizeof(oBuffer), iBuffer, codeset, encode);
			printf("%s", oBuffer);
		}
	} while(readTop != NULL);
}

/***************************************************************************
 *	string2otherEncodeNewString: ʸ¾ΥɤʸȤƳݤ
 *	
 *		char *string2otherEncodeNewString(const char *src, 
 *								CodesetProc codeset, EncodeProc encode);
 *	
 *		const char *src;		ʸ
 *		CodesetProc codeset;	ʸ󤫤ʸȥɤμؿ
 *		EncodeProc encode;		ʸȥɤѴʸ
 *	֤
 *		NULL:		­
 *		NULLʳ:	¾ΥɤѴ줿ݤ줿ʸ
 *	
 *		 codeset() ϡºݤˤϰʲηδؿؤΥݥ󥿤Ǥ
 *		int (*codeset)(unsigned const char **src_ptr, int old, int *type);
 *						
 *		 encode() ϡºݤˤϰʲηδؿؤΥݥ󥿤Ǥ
 *		int (*encode)(unsigned char *dest_ptr, int code, int old, int type);
 *		
 ***************************************************************************/
char *string2otherEncodeNewString(const char *src, 
							CodesetProc codeset, EncodeProc encode)
{
	int length;
	char *buffer;

	length = string2otherCodeset(NULL, 0, src, codeset, encode);
	buffer = (char*)XtMalloc(length + 80);
	if(buffer != NULL) {
		length = string2otherCodeset(buffer, length+10, src, codeset, encode);
	}
	return(buffer);
}

/***************************************************************************
 *	**strArray2cnvNewStrArray: ʸ¾ΥɤѴ
 *	
 *		char **strArray2cnvNewStrArray(const char **src_ptr, 
 *						CodesetProc codeset, EncodeProc encode);
 *	
 *		const char **src_ptr;	ʸNULLݥ󥿽ü
 *		CodesetProc codeset;	ʸ󤫤ʸȥɼؿ
 *		EncodeProc encode;		ʸȥɤѴʸ
 *	֤
 *		NULLʳ:	¾ܸ쥳ɤѴʸ
 *	
 *		 codeset() ϡºݤˤϰʲηδؿؤΥݥ󥿤Ǥ
 *		int (*codeset)(unsigned const char **src_ptr, int old, int *type);
 *						
 *		 encode() ϡºݤˤϰʲηδؿؤΥݥ󥿤Ǥ
 *		int (*encode)(unsigned char *dest_ptr, int code, int old, int type);
 *		
 ***************************************************************************/
char **strArray2cnvNewStrArray(const char **src_ptr, 
						CodesetProc codeset, EncodeProc encode)
{
	int counter;
	int number;
	int length;
	char **buffer_ptr = NULL;

	if(src_ptr != NULL) {
		/***************************************************************
		 *	
		 *		Υ/ѥݥγ/ݥ󥿽
		 ***************************************************************/
		number = arrayCount((void**)src_ptr);
		buffer_ptr = (char**)XtMalloc((number + 1) * sizeof(*buffer_ptr));
		for(counter = 0;buffer_ptr != NULL && counter <= number;++counter) {
			*(buffer_ptr + counter) = NULL;
		}
		/***************************************************************
		 *	ʸѴ
		 *		ѴʸĹ/ġʸΥХåե/Ѵ
		 ***************************************************************/
		for(counter = 0;buffer_ptr != NULL && counter < number &&
								*(src_ptr + counter) != NULL;++counter) {
			length = string2otherCodeset(NULL, 0, 
								*(src_ptr + counter), codeset, encode);
			if(length != EOF) {
				*(buffer_ptr + counter) = (char*)XtMalloc(length + 2);
				if(*(buffer_ptr + counter) != NULL) {
					string2otherCodeset(*(buffer_ptr+counter), 
							length+1, *(src_ptr+counter), codeset, encode);
				}
			} else {
				*(buffer_ptr + counter) = XtNewString(*(src_ptr+counter));
			}
#ifdef	JA_DEBUG
			printf("%s:%d:#%d;%d:%s\n", __FILE__, __LINE__, 
						counter, length, *(buffer_ptr + counter));
#endif	/*JA_DEBUG*/
		}
#ifdef	JA_DEBUG
		for(counter = 0;*(buffer_ptr + counter) != NULL;++counter) {
			printf("%s:%d:#%d:%s\n", __FILE__, __LINE__, counter, *(buffer_ptr + counter));
		}
#endif	/*JA_DEBUG*/
	}
#ifdef	JA_DEBUG
	printf("buffer_ptr = %p\n", buffer_ptr);
#endif	/*JA_DEBUG*/
	return(buffer_ptr);
}

/***************************************************************************
 *	checkJis: ʸ JIS ɤȲꤷƴޤޤʸȰ۾ʸȽ
 *	
 *		unsigned const char *checkJis(unsigned const char *src_ptr, 
 *												int *status, int *type);
 *	
 *		unsigned const char *src_ptr;	ʸȽ򤹤ʸ
 *		int *status;		ޤޤʸȰ۾ʸȽꤹ
 *		int *type;			ʸ
 *	֤
 *		NULL		Ƚꤹ٤ʸ̵ʰ NULL/ʸ
 *		NULLʳ	Ƚꤷʸμʸΰ
 *	
 *		ʸ JIS ɤȲꤷơƬΰʸʸȽꤷơ
 *		*status ˤʸ郎ޤޤƤȤϿ롣
 *		۾ʸɤξϡ۾ʸޤޤƤȤƱͤ
 *		*status ˵Ͽ롣
 *		ʲˤ *status ΰ̣򼨤
 *		
 *		     4        3       2       1       0   
 *		
 *		   ̻   OUTOFRANGEJISX0212JISX0208JISX0201ISO_8859
 *		
 *		ӥåȥޥ  0x0010   0x0008  0x0004  0x0002  0x0001 
 *		
 *		Ǽ̻Ҥϡͤ򥷥եȤ줿ͤӥåȥޥ
 *		͡1 << ̻ҡˤȤʤ롣
 *		
 ***************************************************************************/
unsigned const char *checkJis(unsigned const char *src_ptr, int *status, int *type)
{
	int code = *src_ptr;
	int code1 = *(src_ptr + 1);
	int length;
	int counter;
	const char *sequence;
	static const struct {
		const char *escSequence;
		const int  codeSet;
	} codeInfo[] = {
		{"\x1B\x26\x40\x1B\x24\x42", JISX0208}, /* ESC+'&'+'@'+ESC+'$'+'B' */
		{"\x1B\x24\x28\x44",         JISX0212}, /* ESC+'$'+'('+'D' */
		{"\x1B\x24\x40",             JISX0208}, /* ESC+'$'+'@' */
		{"\x1B\x24\x42",             JISX0208}, /* ESC+'$'+'B' */
		{"\x1B\x28\x49",             JISX0201}, /* ESC+'('+'I' */
		{"\x1B\x28\x42",             ISO_8859}, /* ESC+'('+'B' */
		{"\x1B\x28\x48",             ISO_8859}, /* ESC+'('+'H' */
		{"\x1B\x28\x4A",             ISO_8859}, /* ESC+'('+'J' */
		{NULL,                       ISO_8859}
	};

	if(src_ptr != NULL) {
		while((code = *src_ptr) == '\x1b') {
			for(counter = 0;codeInfo[counter].escSequence != NULL;++counter) {
				sequence = codeInfo[counter].escSequence;
				length = strlen(sequence);
				if(strncmp(sequence, src_ptr, length) == 0) {
					src_ptr += length;
					*type = codeInfo[counter].codeSet;
					break;
				}
			}
			if(codeInfo[counter].escSequence == NULL) {
				src_ptr += (codeInfo[counter].escSequence == NULL);
				*status |= 0x01 << OUTOFRANGE;
			}
		}
		code1 = *(src_ptr + 1);

		if(*type == ISO_8859) {
			*type = ((code < 0x80)?(ISO_8859):(JISX0201));
		}
		if(*src_ptr != '\0') {
			switch(*type) {
			case ISO_8859:
				*status |= ((code & 0x80)?(1 << OUTOFRANGE):(1 << ISO_8859));
				++src_ptr;
				break;
			case JISX0201:
				code = *src_ptr | 0x80;
				*status |= ((code >= 0xa1 && code <= 0xdf)?
									(1 << OUTOFRANGE):(1 << JISX0201));
				++src_ptr;
				break;
			case JISX0212:
			case JISX0208:
				*status |= (((code >= 0x21 && code <= 0x7e) && 
								(code1 >= 0x21 && code1 <= 0x7e))?
										(1 << *type):(1 << OUTOFRANGE));
				src_ptr += 2;
				break;
			}
		} else {
			src_ptr = NULL;
		}
	}
	return(src_ptr);
}

/***************************************************************************
 *	checkSjis: ʸSJISɤȲꤷƴޤޤʸȰ۾ʸȽ
 *	
 *		unsigned const char *checkSjis(unsigned const char *src_ptr, 
 *												int *status, int *type);
 *	
 *		unsigned const char *src_ptr;	ʸȽ򤹤ʸ
 *		int *status;		ޤޤʸȰ۾ʸȽꤹ
 *		int *type;			ʸ
 *	֤
 *		NULL		Ƚꤹ٤ʸ̵ʰ NULL/ʸ
 *		NULLʳ	Ƚꤷʸμʸΰ
 *		
 *	
 *		ʸ JIS ɤȲꤷơƬΰʸʸȽꤷơ
 *		*status ˤʸ郎ޤޤƤȤϿ롣
 *		۾ʸɤξϡ۾ʸޤޤƤȤƱͤ
 *		*status ˵Ͽ롣
 *		ʲˤ *status ΰ̣򼨤
 *		
 *		     4        3       2       1       0   
 *		
 *		   ̻   OUTOFRANGEJISX0212JISX0208JISX0201ISO_8859
 *		
 *		ӥåȥޥ  0x0010   0x0008  0x0004  0x0002  0x0001 
 *		
 *		Ǽ̻Ҥϡͤ򥷥եȤ줿ͤӥåȥޥ
 *		͡1 << ̻ҡˤȤʤ롣
 *		
 ***************************************************************************/
unsigned const char *checkSjis(unsigned const char *src_ptr, int *status, int *type)
{
	int code;
	int code0;
	int code1;

	if(src_ptr != NULL && *src_ptr != '\0') {
		code0 = *src_ptr;
		code1 = *(src_ptr + 1);

		if(((code0 >= 0x81 && code0 <= 0x9f) || 
				(code0 >= 0xe0 && code0 <=  0xfc))
					&& (code1 >= 0x40 && code1 <= 0xfc && code1 != 0x7f)) {
			*type = JISX0208;
		} else {
			*type = ((code0 < 0x80)?(ISO_8859):(JISX0201));
		}
		switch(*type) {
		case ISO_8859:
			*status |= ((code0 & 0x80)?(1 << OUTOFRANGE):(1 << ISO_8859));
			++src_ptr;
			break;
		case JISX0201:
			*status |= ((code0 >= 0xa1 && code0 <= 0xdf)?
										(1 << JISX0201):(1 << OUTOFRANGE));
			++src_ptr;
			break;
		case JISX0212:
		case JISX0208:
			code = (code0 << 8) | code1;
			code = sjis2jis(code);
			code0 = code >> 8;
			code1 = code & 0xff;
			*status |= (((code0 >= 0x21 && code0 <= 0x7e) && 
							(code1 >= 0x21 && code1 <= 0x7e))?
											(1 << *type):(1 << OUTOFRANGE));
			src_ptr += 2;
			break;
		}
	} else {
		src_ptr = NULL;
	}
	return(src_ptr);
}

/***************************************************************************
 *	checkEuc: ʸ JIS ɤȲꤷƴޤޤʸȰ۾ʸȽ
 *	
 *		unsigned const char *checkEuc(unsigned const char *src_ptr, 
 *												int *status, int *type);
 *	
 *		unsigned const char *src_ptr;	ʸȽ򤹤ʸ
 *		int *status;		ޤޤʸȰ۾ʸȽꤹ
 *		int *type;			ʸ
 *	֤
 *		NULL		Ƚꤹ٤ʸ̵ʰ NULL/ʸ
 *		NULLʳ	Ƚꤷʸμʸΰ
 *	
 *		ʸ JIS ɤȲꤷơƬΰʸʸȽꤷơ
 *		*status ˤʸ郎ޤޤƤȤϿ롣
 *		۾ʸɤξϡ۾ʸޤޤƤȤƱͤ
 *		*status ˵Ͽ롣
 *		ʲˤ *status ΰ̣򼨤
 *		
 *		     4        3       2       1       0   
 *		
 *		   ̻   OUTOFRANGEJISX0212JISX0208JISX0201ISO_8859
 *		
 *		ӥåȥޥ  0x0010   0x0008  0x0004  0x0002  0x0001 
 *		
 *		Ǽ̻Ҥϡͤ򥷥եȤ줿ͤӥåȥޥ
 *		͡1 << ̻ҡˤȤʤ롣
 *		
 ***************************************************************************/
unsigned const char *checkEuc(unsigned const char *src_ptr, int *status, int *type)
{
	int code;
	int code0;
	int code1;

	if(src_ptr != NULL && *src_ptr != '\0') {
		code  = *src_ptr;
		code0 = *src_ptr;
		code1 = *(src_ptr + 1);

		*type = ((code < 0x80)?(ISO_8859):(JISX0208));
		*type += (code == SS3) - (code == SS2);
		switch(*type) {
		case ISO_8859:
			*status |= ((code0 & 0x80)?(1 << OUTOFRANGE):(1 << ISO_8859));
			++src_ptr;
			break;
		case JISX0201:
			*status |= ((code1 >= 0xa1 && code1 <= 0xdf)?
										(1 << OUTOFRANGE):(1 << JISX0201));
			++src_ptr;
			code = *src_ptr;
			++src_ptr;
			break;
		case JISX0212:
			code = *++src_ptr;
			code0 = *src_ptr;
			code1 = *(src_ptr + 1);
			/* ʲν³ */
		case JISX0208:
			*status |= (((code0 >= 0xa1 && code0 <= 0xfe) && 
							(code1 >= 0xa1 && code1 <= 0xfe))?
											(1 << *type):(1 << OUTOFRANGE));
			src_ptr += 2;
			break;
		}
	}
	return(src_ptr);
}

/***************************************************************************
 *	whatTest: ɤΥɥåȹԤ򤹤
 *	
 *		static int whatTest(CodeSetsCheck codesets[]);
 *	
 *		CodeSetsCheck codesets[];	ߤΥɼȽ
 *	֤
 *		JaJIS (=0):	JIS (ISO 2022-1993/JIS X 0202-1991)󥳡Ƚ
 *		JaEUC (=1):	ܸ EUC  󥳡Ƚ
 *		JaSJIS(=2):	եJIS (ms-kanji) 󥳡Ƚ
 *		EOF:	ɥåλ
 *	
 *		ޤǤΥɼȽȽ֤ΤΤå
 *		롣
 *		
 *		  codesets[]ʸߤΥɼȽ ΰ̣
 *		
 *		
 *		 checkChar() status   type  src_ptr 
 *		
 *		 JIS   checkJis()      0       0    NULL  
 *		
 *		 EUC   checkEuc()      0       0    NULL  
 *		
 *		SJIS   checkSjis()     0       0    NULL  
 *		
 *		ü󡡨NULL     0       0  NULL
 *		
 *		
 *		
 *		
 *		å
 *		ʸ󡡡
 *		
 *		
 *		
 *		
 *		
 *		ʸʸ src_ptr 򥳡ɥåо
 *		ˤ롣
 *		Ǥϡΰ֤ؤƤ JIS ɤΥåԤޤ
 *	ջ
 *		ι¤򸵤˥å٤󥳡ɤμ̤뤿ᡢ
 *		֤ͤΰ̣ϡ codesets[] ƤˤäѤ롣嵭Υ
 *		̤ˤʤ뤿ˤϡ codesets[] 嵭ƤǤʤФʤ
 *		
 *	Ȼ
 *		CodeSetsCheckɼȽѹ¤Ρluty.h
 *		JaLocales 󷿡luty.h
 *		
 ***************************************************************************/
static int whatTest(CodeSetsCheck codesets[])
{
	int counter;
	int selected = EOF;		/* EOFʥɥåλ */
	unsigned const char *searched = NULL;	/* åо */
	int result;

	if(codesets[0].checkChar != NULL) {
		for(counter = 1, selected = 0, searched = codesets[0].src_ptr;
						codesets[counter].checkChar != NULL;++counter) {
			/*
			 *	printf("[%p]:%s\n", codesets[counter].src_ptr, 
			 *							codesets[counter].src_ptr);
			 */
			if(searched == NULL || codesets[counter].src_ptr < searched ) {
				if(codesets[counter].src_ptr != NULL) {
					selected = counter;
				}
				searched = codesets[counter].src_ptr;
			}
		}
	}
	result = (searched != NULL && *searched != '\0')?(selected):(EOF);
	/*printf("whatTest():result is %d.\n", result);*/
	return(result);
}

/***************************************************************************
 *	onlyOne: ߤΥɼȽ饨󥳡ɤǤ뤫å
 *	
 *		static int onlyOne(const CodeSetsCheck codesets[], int needType);
 *	
 *		const CodeSetsCheck codesets[];		ߤΥɼȽ
 *		int needType;				󥳡ɤɬפʸ
 *	֤
 *		JaJIS (=0):	JIS (ISO 2022-1993/JIS X 0202-1991)󥳡Ƚ
 *		JaEUC (=1):	ܸ EUC  󥳡Ƚ
 *		JaSJIS(=2):	եJIS (ms-kanji) 󥳡Ƚ
 *		EOF:		󥳡ɼ̤
 *	
 *		ߤΥɼȽ饨󥳡ɤǤ뤫Ĵ٤ޤ
 *		֤ͤϡ codesets[] ˰¸뤿ᡢȤʤȽ
 *		򼨤
 *		
 *		  codesets[]ʸߤΥɼȽ ΰ̣
 *		
 *		
 *		 checkChar() status   type  src_ptr 
 *		
 *		 JIS   checkJis()      0       0    NULL  
 *		
 *		 EUC   checkEuc()      0       0    NULL  
 *		
 *		SJIS   checkSjis()     0       0    NULL  
 *		
 *		ü󡡨NULL     0       0  NULL
 *		
 *		
 *		椫饨󥳡ɳΤϡstatus Сѿ˵Ͽ
 *		ƤޤѿͤϡʲΤ褦ʥӥåȥޥˤʤäƤޤ
 *		
 *		  codesets[].statusʸߤΥɼȽˤΰ̣
 *		
 *		
 *		   bit4     bit3    bit2    bit1    bit0  
 *		
 *		   ̻   OUTOFRANGEJISX0212JISX0208JISX0201ISO_8859
 *		
 *		ӥåȥޥ  0x0010   0x0008  0x0004  0x0002  0x0001 
 *		
 * 		
 * 		ʤӥåȥޥåפȼ̻Ҥδطϡ1 << OUTOFRANGE = 0x0010 ȸ
 *		褦ˡ1 << [̻] = [ӥåȥޥ] δطˤʤޤ
 * 		
 *		ϡߤޤǤȽꤵ줿ʸˡ嵭ʸޤޤƤ
 *		뤫򼨤ƤޤΥӥåȥޥϡʲΤ褦ʰ̣Ǥ
 *		
 *		  ISO_8859 ġġ ASCII ɡ0x000x7f
 *		  JISX0201 ġġ JIS ʥʡ˥
 *		  JISX0208 ġġ JIS ɡ//
 *		  JISX0212 ġġ JIS 
 *		  OUTOFRANGE ġ ϰϤȤŬʰ۾ʸʸμ
 *							ȤŬǤʤʸɤȵϿ롣
 *		
 *		JIS ɤϡASCII ɤޤबǤص˥ʤΤߡ
 *		
 *		̾ϡʲΤ褦ˡ codesets[].status  OUTOFRANGEʥ
 *		ϰϤȤŬʰ۾ʸˤȽꤵ줿ɤޤޤʤ
 *		ɼ郎ष̵ȤˡŬʥ󥳡ɼ郎Ǥޤ
 *		ʤΤ褦ȽϡneedType  0 ΤȤ˹Ԥޤ
 *		
 *		
 *		   bit4     bit3    bit2    bit1    bit0  
 *		
 *		   ̻   OUTOFRANGEJISX0212JISX0208JISX0201ISO_8859
 *		
 *		 JIS        
 *		
 *		 EUC      
 *		
 *		SJIS        
 *		
 *		
 *		ʲΤ褦ˡOUTOFRANGEʥϰϤȤŬʰ۾ʸ
 *		ǤȽǤʤȤ needType	ȤäơʤळȤ
 *		Ǥޤ
 *		
 *		
 *		   bit4     bit3    bit2    bit1    bit0  
 *		
 *		   ̻   OUTOFRANGEJISX0212JISX0208JISX0201ISO_8859
 *		
 *		 JIS        
 *		
 *		 EUC        
 *		
 *		SJIS        
 *		
 *		
 *		ǤϡneedType = JISX0212ˡJISX0201Ⱦѥʡ
 *		ǡʤळȤǡEUC Ǥޤ
 *		ȤĶϾʤɡġġ
 *		
 ***************************************************************************/
static int onlyOne(const CodeSetsCheck codesets[], int needType)
{
	int counter;		/* 󥳡ɼФ롼ץ */
	int selectable;		/* 󥳡ɼबǤνʣå */
	int selected = EOF;	/* 󥳡ɼǤ󥳡ɼ */
	int result;			/* ֤ */

	for(counter = 0, selectable = 0;
						codesets[counter].checkChar != NULL;++counter) {
		if(!(codesets[counter].status & (0x01 << OUTOFRANGE))) {
			if((codesets[counter].status & needType) == needType) {
				selected = counter;
				++selectable;
			}
		}
	}
	/*********************************************************************
	 *	󥳡ɽʣȽåʣƤʤʳǤˤȤ
	 *	Ƚ̤ result ֤
	 *********************************************************************/
	result = (selectable == 1)?(selected):(EOF);
	/*printf("onlyOne():result is %d.\n", result);*/
	return(result);
}


/***************************************************************************
 *	probableDetect: ͭ˾ʥ󥳡ɤθꤹ
 *	
 *		static int probableDetect(const CodeSetsCheck codesets[], 
 *									int determination, int lineCount);
 *	
 *		const CodeSetsCheck codesets[];	ߤΥɼȽ
 *		int determination;				ư̥󥳡ɡEOF:̤
 *		int lineCount;					ߤޤǤȽ̤Τ˻ѤԿ
 *	֤
 *		JaJIS (=0):	JIS (ISO 2022-1993/JIS X 0202-1991)󥳡Ƚ
 *		JaEUC (=1):	ܸ EUC  󥳡Ƚ
 *		JaSJIS(=2):	եJIS (ms-kanji) 󥳡Ƚ
 *		EOF:		󥳡ɼ̤
 *	
 *		ߤξ֤̤֤ʤ顢Ȥϸʤͭ˾ʥ󥳡ɤ
 *		ꤹ
 *		
 ***************************************************************************/
static int probableDetect(const CodeSetsCheck codesets[], 
									int determination, int lineCount)
{
	int counter;
	int order[] = {0, 1, 2, EOF};
#ifdef	TEST
	int probability = 0;
	const char *pmarks = "********";
	const char *spaces = "        ";
	const char flag[2] = {'*', '-'};
	const char anko[5][2] = 
		{{'a', '-'}, {'n', '-'}, {'k', '-'}, {'o', '-'}, {'x', '-'}};
#endif /*TEST*/

#ifdef	TEST
	probability += (determination != EOF);
#endif /*TEST*/
	if(determination == EOF) {
		determination = onlyOne(codesets, (1 << JISX0208));
	}
#ifdef	TEST
	probability += (determination != EOF);
#endif /*TEST*/
	if(determination == EOF) {
		determination = onlyOne(codesets, (1 << JISX0212));
	}
#ifdef	TEST
	probability += (determination != EOF);
#endif /*TEST*/
	if(determination == EOF) {
		determination = onlyOne(codesets, (1 << JISX0201));
	}
#ifdef	TEST
	probability += (determination != EOF);
#endif /*TEST*/
	for(counter = 0;order[counter] != EOF && determination == EOF;++counter) {
		if(!(codesets[order[counter]].status & (0x01 << OUTOFRANGE))) {
			determination = order[counter];
		}
	}
#ifdef	TEST
	probability += (determination != EOF);
	if(verbose) {
		for(counter = 0;codesets[counter].checkChar != NULL;++counter) {
			printf("%-*s %c %c%c%c%c%c %*.*s %4d %s\n", maxLength, 
				encodeName[counter], flag[(determination != counter)], 
				anko[4][((codesets[counter].status & 0x10) == 0x00)],
				anko[0][((codesets[counter].status & 0x01) == 0x00)], 
				anko[1][((codesets[counter].status & 0x02) == 0x00)], 
				anko[2][((codesets[counter].status & 0x04) == 0x00)], 
				anko[3][((codesets[counter].status & 0x08) == 0x00)],
				6, probability, pmarks, 
				((codesets[counter].detectAt == EOF)?(lineCount):
							(codesets[counter].detectAt)), fileName);
		}
	}
#endif /*TEST*/
	return(determination);
}

/***************************************************************************
 *	checkEncode: 󥳡ɤå
 *	
 *		int checkEncode(const void *stringInfo, 
 *				unsigned const char *(*stringOut)(const void *stringInfo), 
 *						const void *(*nextString)(const void *stringInfo));
 *	
 *		const void *stringInfo;
 *		unsigned const char *(*stringOut)(const void *stringInfo);
 *		const void *(*nextString)(const void *stringInfo);
 *	֤
 *		JaJIS (=0):	JIS (ISO 2022-1993/JIS X 0202-1991)󥳡Ƚ
 *		JaEUC (=1):	ܸ EUC  󥳡Ƚ
 *		JaSJIS(=2):	եJIS (ms-kanji) 󥳡Ƚ
 *		EOF:	󥳡ɼ̤¿ˤʤϤ
 *	
 *		ʸʸĥȥ졼ơܸΤ줾Υη
 *		ȤƲꤷơʸȾѥʤJIS/JIS
 *		۾ʸɤޤޤƤʤɤå۾ʸ
 *		ɤޤޤƤϡʸɤǤϤʤȽꤷơʤ
 *		ޤ
 *		
 *		
 *		
 *		
 *		
 ***************************************************************************/
int checkEncode(const void *stringInfo, 
			unsigned const char *(*stringOut)(const void *stringInfo), 
						const void *(*nextString)(const void *stringInfo))
{
	int counter;			/* 󥳡ɼ̤б롼ץ */
	int selected;			/* Υ󥳡ɤȲꤷƥåо */
	int determination = EOF;		/* 󥳡ɳEOF̤ */
	const unsigned char *stringTop;
	CodeSetsCheck codesets[] = {
		{checkJis,  0, 0, EOF, NULL}, 	/* JIS ɤȲꤷ۾ʸȽ */
		{checkEuc,  0, 0, EOF, NULL},	/* EUC ɤȲꤷ۾ʸȽ */
		{checkSjis, 0, 0, EOF, NULL},	/* SJISɤȲꤷ۾ʸȽ */
		{NULL,      0, 0, EOF, NULL}
	};
	int lineCount = 0;

	for(counter = 0;codesets[counter].checkChar != NULL;++counter) {
		codesets[counter].status = 0x00;	/*  */
	}
	for(++lineCount;stringInfo != NULL && determination == EOF;++lineCount,
		stringInfo = ((nextString != NULL)?(nextString(stringInfo)):(NULL))) {
		if(stringOut == NULL) {
			stringTop = (unsigned const char*)stringInfo;
		} else {
			stringTop = stringOut(stringInfo);
		}
		/*printf("%s", stringTop);*/
		/***********************************************
		 *	󥳡ɥå֤ʸƬˤ
		 ***********************************************/
		for(counter = 0;codesets[counter].checkChar != NULL;++counter) {
			codesets[counter].src_ptr = stringTop;
		}
		while((determination = onlyOne(codesets, 0x00)) == EOF && 
							(selected = whatTest(codesets)) != EOF) {
			codesets[selected].src_ptr = 
				codesets[selected].checkChar(codesets[selected].src_ptr, 
					&codesets[selected].status, &codesets[selected].type);
		}
#ifdef	TEST
		if(codesets[selected].detectAt == EOF && 
				codesets[selected].status & (0x01 << OUTOFRANGE)) {
			codesets[selected].detectAt = lineCount;
		}
#endif	/*TEST*/
	}
	determination = probableDetect(codesets, determination, lineCount);
	return(determination);
}

/***************************************************************************
 *	arrayStringOut: 
 *	
 *		unsigned const char *arrayStringOut(const void *stringInfo);
 *	
 *		const void *stringInfo;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
unsigned const char *arrayStringOut(const void *stringInfo)
{
	return(*(unsigned const char**)stringInfo);
}

/***************************************************************************
 *	arrayNextString: 
 *	
 *		const void *arrayNextString(const void *stringInfo);
 *	
 *		const void *stringInfo;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
const void *arrayNextString(const void *stringInfo)
{
	return(++stringInfo);
}

/***************************************************************************
 *	*lineLinkStringOut: 
 *	
 *		unsigned const char *lineLinkStringOut(const void *stringInfo);
 *	
 *		const void *stringInfo;
 *	֤
 *		NULL:		Ǥ˥󥯤äƤ
 *		NULLʳ:	ʸƬؤݥ
 *	
 *		ʸƬ
 *	
 *	 stringInfo λؤɥ쥹
 *		
 *		
 *		ʸ󡡡֤͡ˡ
 *		
 *		ؤΥ󥯨
 *	
 *	
 *	
 ***************************************************************************/
unsigned const char *lineLinkStringOut(const void *stringInfo)
{
	const LineLink *lineLink = (const LineLink*)stringInfo;

	return(lineLink->string);
}

/***************************************************************************
 *	*lineLinkNextString: 
 *	
 *		const void *lineLinkNextString(const void *stringInfo);
 *	
 *		const void *stringInfo;
 *	֤
 *		
 *	
 *		ʸƬ
 *	
 *	ʸ󡡡
 *	
 *	ؤΥ󥯨ʸ󡡡ʸ
 *	
 *	ؤΥ󥯨ʸ󡡡
 *	
 *	ؤΥ󥯨
 *	
 *	NULLݥ
 *	
 ***************************************************************************/
const void *lineLinkNextString(const void *stringInfo)
{
	const LineLink *lineLink = (const LineLink*)stringInfo;

	return((const void*)lineLink->next_ptr);
}

#ifdef TEST

#ifndef TRUE
#define TRUE	(1)
#endif	/*TRUE*/

#ifndef FALSE
#define FALSE	(0)
#endif	/*FALSE*/

/***************************************************************************
 *	main: ᥤؿ
 *	
 *		int main(int argc, char **argv);
 *	
 *		int argc;		θĿ
 *		char **argv;	ʸ
 *	֤
 *		0:		ｪλ
 *		0ʳ:	顼
 *	
 *		
 ***************************************************************************/
int main(int argc, char **argv)
{
	int counter;
	int autoDetect = FALSE;
	int encodeDisplay = FALSE;
	int files = 0;
	int loopOut = 0;
	int c, options = 0;
	int currentDeviceName = 0;
	LineLink *fileLines;
	int encodeType;
	FILE *fp;
	char *prog = *argv;
	char *locale = getenv("LANG");
	char *encodeNameJa[] = {"JIS ", "ܸ EUC", "եJIS", "̤"};
	char *encodeNameEn[] = {"ja_JP.JIS", "ja_JP.ujis", "ja_JP.SJIS", "Unknown"};
	int (*codeset)(unsigned const char **src_ptr, int old, int *type) = NULL;
	int (*encode)(unsigned char *dest, int code, int old, int type) = NULL;
	int (*codesets[])(unsigned const char **src_ptr, int old, int *type) = 
									{codesetJis, codesetSjis, codesetEuc};
	int (*encodes[])(unsigned char *dest, int code, int old, int type) = 
										{encodeJis1, encodeSjis, encodeEuc};

	if(strcmp(locale, "ja_JP.ujis") == 0) {
		encodeName = encodeNameJa;
	} else {
		encodeName = encodeNameEn;
	}
	while (--argc > 0) {
		if(**++argv == '-') {
			loopOut = 0;
			while ((c = *++*argv) != '\0') {
				switch (c) {
				case '-':
					autoDetect = TRUE;
					++options;
					break;
				case 'L':
					encodeName = encodeNameEn;
					break;
				case 'v':
					verbose = TRUE;
					break;
				case 'l':
					encodeDisplay = TRUE;
					++options;
					break;
				case 'J':
					encodes[0] = encodeJis2;
					break;
				case 'j':
					if(options == 0) {
						codeset = codesets[0];
					}
					if(options == 1) {
						encode = encodes[0];
					}
					++options;
					break;
				case 's':
				case 'S':
					if(options == 0) {
						codeset = codesets[1];
					}
					if(options == 1) {
						encode = encodes[1];
					}
					++options;
					break;
				case 'e':
				case 'E':
					if(options == 0) {
						codeset = codesets[2];
					}
					if(options == 1) {
						encode = encodes[2];
					}
					++options;
					break;
				}
			}
		}
		for(counter = 0;counter < 4;++counter) {
			maxLength = max(maxLength, strlen(encodeName[counter]));
		}
		if((c = **argv) != '\0') {
			/* printf("OPEN \"%s\"\n", *argv); */
			if((fp = fopen(*argv, "r")) != NULL) {
				++files;
				if(autoDetect) {
					fileLines = file2lines(fp);
					fileName = *argv;
					encodeType = checkEncode(fileLines,
										lineLinkStringOut, lineLinkNextString);
					fseek(fp, 0, SEEK_SET);
					if(encodeDisplay && !verbose) {
						printf("%s %s\n", encodeName[encodeType], *argv);
					}
				}
				if(!encodeDisplay) {
					streamConvert(fp, codeset, encode);
				}
				fclose(fp);
			}
		}
	}
	if(files == 0) {
		/*printf("stdin\n");*/
		streamConvert(stdin, codeset, encode);
	}
	return(0);
}
#endif /*TEST*/
