/***************************************************************************
 *	l_uty.c: Locale 桼ƥƥ
 *	
 *		Date. 1997/08/07 -- 
 *			Programed by Nobuyuki Maruichi
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>

/***********************************************
 *	ѤΥ󥯥롼ɡե
 ***********************************************/
#include "luty.h"

#define	 min(a,b)		(((a)<(b))?(a):(b))

/***************************************************************************
 *	skipSpace: Ϣ³ʸʥ֡Ԥޤˤ
 *	
 *		int skipSpace(const char *line);
 *	
 *		const char *line;
 *	֤
 *		Ϣ³ʸʥ֡Ԥޤˤ
 *	
 *		
 ***************************************************************************/
int skipSpace(const char *line)
{
	int counter;

	for(counter = 0;line != NULL && *(line + counter) != '\0' && 
									isspace(*(line + counter));++counter)
		;			/*  */
	return(counter);
}

/***************************************************************************
 *	messageAlloc: ʬĥ꡼ΥΡɤݤ
 *	
 *		MessageNode *messageAlloc(const char *line);
 *	
 *		const char *line;		åʸ
 *	֤
 *		NULL:		åγݤ˼
 *		NULLʳ:	ݤå
 *	
 *		
 ***************************************************************************/
MessageNode *messageAlloc(const char *line)
{
	int mesLength;
	int keyLength;
	char buffer[256];
	const char *nextMessage;
	const char *messString;
	MessageNode *alloc_ptr = NULL;

	messString = strchr(line, ':');
	nextMessage = strchr(line, '\n');
	if(nextMessage == NULL) {
		nextMessage = line + strlen(line);
	}
	if(messString != NULL && nextMessage != NULL) {
		keyLength = messString - line;
		mesLength = nextMessage - messString - 1;
		if(keyLength > 0 && mesLength > 0) {
			sprintf(buffer, "%.*s", 
				min(keyLength, sizeof(buffer)-1), line);
			alloc_ptr = (MessageNode*)XtMalloc(sizeof(MessageNode));
			alloc_ptr->keyword = XtNewString(buffer + skipSpace(buffer));
			sprintf(buffer, "%.*s", min(mesLength, sizeof(buffer)-1), messString+1);
			alloc_ptr->message = XtNewString(buffer);
			alloc_ptr->lowerLink  = NULL;
			alloc_ptr->higherLink = NULL;
			/*printf("***%s***%s***\n", alloc_ptr->keyword, alloc_ptr->message);*/
		}
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	messageLink: ʬĥ꡼ΥΡɤؤϿԤ
 *	
 *		MessageNode *messageLink(MessageNode **node, MessageNode *newMess);
 *	
 *		MessageNode **node;		ĥ꡼ˤʤäƤΡ
 *		MessageNode *newMess;	Ρ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void messageLink(MessageNode **node, MessageNode *newMess)
{
	int result;

	if(*node == NULL) {
		*node = newMess;
	} else {
		result = strcmp((*node)->keyword, newMess->keyword);
		if(result != 0) {
			if(result > 0) {
				messageLink(&(*node)->lowerLink, newMess);
			} else {
				messageLink(&(*node)->higherLink, newMess);
			}
		} else {
			XtFree((char*)newMess->keyword);
			XtFree((char*)newMess->higherLink);
			XtFree((char*)newMess);
		}
	}
	return;
}

/***************************************************************************
 *	linelength: åĹ
 *	
 *		int linelength(const char *line);
 *	
 *		const char *line;	åʸ'\n'ˤޤ
 *	֤
 *		åĹ
 *	
 *		
 ***************************************************************************/
int linelength(const char *line)
{
	int length = 0;
	const char *nextLine;

	nextLine = strchr(line, '\n');
	if(nextLine == NULL) {
		length = strlen(line);
	} else {
		length = nextLine - line + 1;
	}
	return(length);
}

/***************************************************************************
 *	makeMessages: åʸ򥭡ɤ鸡ǽʼˤ
 *	
 *		MessageNode *makeMessages(const char *messages);
 *	
 *		MessageNode *topMess;	ɲäΡɡʿΤȤϡNULL
 *		const char *messages;	åʸ'\n'ˤޤ
 *	֤
 *		NULL:		ι˼
 *		NULLʳ:	åʬĥ꡼
 *	
 *		åʸ򥭡ɤ鸡ǽʼˤ롣
 *		kˡ
 *		1 ¸Τ򥭡ɸɲäϡ topMess ˴
 *			¸Τꤹ롣
 *		2 Υɼϡ topMess  NULL 
 *			ꤹ롣
 ***************************************************************************/
MessageNode *makeMessages(MessageNode *topMess, const char *messages)
{
	const char *line;
	MessageNode *newMess = NULL;

	for(line = messages;
			line != NULL && *line != '\0';line += linelength(line)) {
		newMess = messageAlloc(line);
		if(newMess != NULL) {
			messageLink(&topMess, newMess);
		} else {
			printf("newMess is NULL\n");
		}
	}
	return(topMess);
}

/***************************************************************************
 *	printTree: ǥХåѤˣʬĥ꡼ɽ
 *	
 *		void printTree(MessageNode *node);
 *	
 *		MessageNode *node;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void printTree(MessageNode *node)
{
	if(node == NULL)
		return;
	printTree(node->lowerLink);
	printf("%s:%s\n", node->keyword, node->message);
	printTree(node->higherLink);
}

/***************************************************************************
 *	messageSearch: ʬĥ꡼ꤵ줿ɤǸ
 *	
 *		MessageNode *messageSearch(const MessageNode *node, const char *keyword);
 *	
 *		const MessageNode *node;	ʬĥ꡼κȡʸϰ֡
 *		const char *keyword;		
 *	֤
 *		NULL:		ꤵ줿ɤĤʤä
 *		NULLʳ:	ꤵ줿ɤޤΥΡ
 *	
 *		
 ***************************************************************************/
const MessageNode *messageSearch(const MessageNode *node, const char *keyword)
{
	int status;
	const MessageNode *result_ptr = NULL;

	if(node != NULL && node->keyword != NULL && keyword != NULL) {
		status = strcmp(node->keyword, keyword);
		switch(status) {
		case 0:
			result_ptr = node;
			break;
		default:
			if(status > 0) {
				result_ptr = messageSearch(node->lowerLink, keyword);
			} else {
				result_ptr = messageSearch(node->higherLink, keyword);
			}
			break;
		}
	}
	return(result_ptr);
}

#ifdef	TEST
/***************************************************************************
 *	main: ƥѤΥᥤؿ
 *	
 *		void main(void);
 *	
 *		void;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void main(void)
{
	MessageNode *top;
	const char *testString = 
		"ENOENT:No such file or directory\n"
		"permisson denied:븢¤ޤ\n"
		"Syntax Error:ʸˡθ\n"
		"filesystem full: ե륷ƥबäѤˤʤޤ\n"
		"ESRCH:No such process";
	
	top = makeMessages(testString);
	printTree(top);
}

#endif	/*TEST*/
